#include <oxstd.h>
#include <oxprob.h>
#include <oxdraw.h>
#include <oxfloat.h>
#import "maximize"
//#import <packages/maxsa/maxsa>

static decl s_mPred, s_mScaledResids, s_mWith, s_mRetExp, s_mPredicted, s_mEmpirical, s_mExposures, s_mProbIntegralsMacrosAlt, s_mProbIntegralsMacros, s_mProbIntegralsLGDs, s_mScaledScores, s_mScores, s_mMeans, s_mYv, s_mAB, s_mYr, s_mYg, s_mYc, s_mRp, s_mLogOdds, s_mFactors, s_mProbs;
static decl s_iModel, s_iNumObs, s_iNumFactors, s_iNumRecRates, s_iRestrict;
static decl s_iNumGrades, s_iNumIndustriesLGD, s_iNumIndustries, s_iNumMacroFactors, s_iNumRecRateFactors, s_iNumFrailtyFactors, s_iNumMacros, s_iNumTransitionTypes;
static decl s_vFactors, s_vDurations, s_vTime, s_vTau, s_iPrint, s_iPlot, s_iInfoSmooth, s_mZg;
static decl s_vParmsOrig;

restrictParms(const vParmsBegin)
{
	decl vParms = vParmsBegin .* s_vParmsOrig;
	decl vRestrictedParms = vParms;
	decl temp;
	decl inc = 0;

	if(s_iModel==1)
	{
		// A parameters
		vRestrictedParms[inc : inc + s_iNumFactors - 1] = vParms[inc : inc + s_iNumFactors - 1]/100;
		inc += s_iNumFactors;
		// B parameters
		vRestrictedParms[inc : inc + s_iNumFactors - 1] = 1 ./ (1 + exp(-vParms[inc : inc + s_iNumFactors - 1]));
		inc += s_iNumFactors;
		// vZc parameters
		inc += s_iNumGrades^2;
		// mZc
		inc += (s_iNumGrades - s_iNumFactors)*s_iNumFactors;//(s_iNumGrades*s_iNumFactors) - s_iNumFrailtyFactors - s_iNumRecRateFactors;
		// Dummies
		inc += 2 * s_iNumGrades;
	}
	else if(s_iModel==2)
	{
		// A parameters
		vRestrictedParms[inc : inc + s_iNumFactors - 1] = vParms[inc : inc + s_iNumFactors - 1]/100;
		inc += s_iNumFactors;
		// B parameters
		vRestrictedParms[inc : inc + s_iNumFactors - 1] = 1 ./ (1 + exp(-vParms[inc : inc + s_iNumFactors - 1]));
		inc += s_iNumFactors;
		// mZg
		inc += (s_iNumMacros - s_iNumMacroFactors)*s_iNumMacroFactors;
		// vSigma2 parameters for macros
		vRestrictedParms[inc: inc + s_iNumMacros - 1] = exp(vParms[inc: inc + s_iNumMacros - 1]);
		inc += s_iNumMacros;
		// vZc parameters
		inc += s_iNumGrades^2;
		// mZc
		inc += (s_iNumGrades*s_iNumFactors) - s_iNumFrailtyFactors^2 - s_iNumGrades*s_iNumRecRateFactors;
		// Dummies
		inc += 2 * s_iNumGrades;
	}
	else if((s_iModel>=3)&&(s_iModel<11))
	{
		// A parameters
		vRestrictedParms[inc : inc + s_iNumFactors - 1] = vParms[inc : inc + s_iNumFactors - 1]/100;
		inc += s_iNumFactors;
		// B parameters
		vRestrictedParms[inc : inc + s_iNumFactors - 1] = 1 ./ (1 + exp(-vParms[inc : inc + s_iNumFactors - 1]));
		inc += s_iNumFactors;
		// mZg
		inc += (s_iNumMacros - s_iNumMacroFactors)*s_iNumMacroFactors;
		// vSigma2 parameters for macros
		vRestrictedParms[inc: inc + s_iNumMacros - 1] = exp(vParms[inc: inc + s_iNumMacros - 1]);
		inc += s_iNumMacros;
		// vZc parameters
		inc += s_iNumGrades^2;
		// mZc
		inc += (s_iNumGrades*s_iNumFactors) - s_iNumFrailtyFactors^2 - s_iNumGrades*s_iNumRecRateFactors;
		// dSigma2
		vRestrictedParms[inc] = exp(vParms[inc]);
		inc += 1;
		// vZr
		inc += 1;
		// mZr
		inc += s_iNumFactors - s_iNumRecRateFactors;
		// Dummies
		inc += 2 * s_iNumGrades;
	}
	else if(s_iModel==11)
	{
		// A parameters
		vRestrictedParms[inc : inc + s_iNumFactors - 1] = vParms[inc : inc + s_iNumFactors - 1]/100;
		inc += s_iNumFactors;
		// B parameters
		vRestrictedParms[inc : inc + s_iNumFactors - 1] = 1 ./ (1 + exp(-vParms[inc : inc + s_iNumFactors - 1]));
		inc += s_iNumFactors;
		// mZg
		inc += (s_iNumMacros - s_iNumMacroFactors)*s_iNumMacroFactors + s_iNumMacroFactors*(s_iNumMacroFactors-1)/2;
		// vSigma2 parameters for macros
		vRestrictedParms[inc: inc + s_iNumMacros - 1] = exp(vParms[inc: inc + s_iNumMacros - 1]);
		inc += s_iNumMacros;
		// vZc parameters
		inc += s_iNumGrades^2;
		// mZc
		//inc += (s_iNumGrades*s_iNumFactors) - s_iNumFrailtyFactors^2 - s_iNumGrades*s_iNumRecRateFactors;
		inc += s_iNumGrades*s_iNumMacroFactors + s_iNumFrailtyFactors*s_iNumGrades - s_iNumFrailtyFactors*(s_iNumFrailtyFactors + 1)/2; 
		// dSigma2
		vRestrictedParms[inc] = exp(vParms[inc]);
		inc += 1;
		// vZr
		inc += 1;
		// mZr
		inc += s_iNumFactors - s_iNumRecRateFactors;
		// Dummies
		inc += 2 * s_iNumGrades;
		
	}
	else if(s_iModel==12)
	{
		// A parameters
		vRestrictedParms[inc : inc + s_iNumFactors - 1] = vParms[inc : inc + s_iNumFactors - 1]/100;
		inc += s_iNumFactors;
		// B parameters
		vRestrictedParms[inc : inc + s_iNumFactors - 1] = 1 ./ (1 + exp(-vParms[inc : inc + s_iNumFactors - 1]));
		inc += s_iNumFactors;
		// mZg
		inc += (s_iNumMacros - s_iNumMacroFactors)*s_iNumMacroFactors + s_iNumMacroFactors*(s_iNumMacroFactors-1)/2;
		// vSigma2 parameters for macros
		vRestrictedParms[inc: inc + s_iNumMacros - 1] = exp(vParms[inc: inc + s_iNumMacros - 1]);
		inc += s_iNumMacros;
		// vZc parameters
		inc += s_iNumGrades^2;
		// mZc
		//inc += (s_iNumGrades*s_iNumFactors) - s_iNumFrailtyFactors^2 - s_iNumGrades*s_iNumRecRateFactors;
		inc += s_iNumGrades*s_iNumMacroFactors + s_iNumFrailtyFactors*s_iNumGrades - s_iNumFrailtyFactors*(s_iNumFrailtyFactors + 1)/2; 
		// dSigma2
		vRestrictedParms[inc] = exp(vParms[inc]);
		inc += 1;
		// vZr
		inc += 1;
		// mZr
		inc += s_iNumFactors - s_iNumRecRateFactors;
		// Dummies
		inc += 2 * s_iNumGrades;
	}
	else if(s_iModel==13)
	{
		// A parameters
		vRestrictedParms[inc : inc + s_iNumFactors - 1] = vParms[inc : inc + s_iNumFactors - 1]/100;
		inc += s_iNumFactors;
		// B parameters
		vRestrictedParms[inc : inc + s_iNumFactors - 1] = 1 ./ (1 + exp(-vParms[inc : inc + s_iNumFactors - 1]));
		inc += s_iNumFactors;
		// mZg
		inc += (s_iNumMacros - s_iNumMacroFactors)*s_iNumMacroFactors + s_iNumMacroFactors*(s_iNumMacroFactors-1)/2;
		// vSigma2 parameters for macros
		vRestrictedParms[inc: inc + s_iNumMacros - 1] = exp(vParms[inc: inc + s_iNumMacros - 1]);
		inc += s_iNumMacros;
		// vZc parameters
		inc += s_iNumGrades^2;
		// mZc
		//inc += (s_iNumGrades*s_iNumFactors) - s_iNumFrailtyFactors^2 - s_iNumGrades*s_iNumRecRateFactors;
		inc += s_iNumGrades*s_iNumMacroFactors + s_iNumFrailtyFactors*s_iNumGrades - s_iNumFrailtyFactors*(s_iNumFrailtyFactors + 1)/2; 
		// dSigma2
		vRestrictedParms[inc] = exp(vParms[inc]);
		inc += 1;
		// vZr
		inc += 1;
		// mZr
		inc += s_iNumFactors - s_iNumRecRateFactors;
		// Dummies
		inc += 2 * s_iNumGrades;
	}
	else if(s_iModel==14)
	{
		// A parameters
		vRestrictedParms[inc : inc + s_iNumFactors - 1] = vParms[inc : inc + s_iNumFactors - 1]/100;
		inc += s_iNumFactors;
		// B parameters
		vRestrictedParms[inc : inc + s_iNumFactors - 1] = 1 ./ (1 + exp(-vParms[inc : inc + s_iNumFactors - 1]));
		inc += s_iNumFactors;
		// mZg
		inc += (s_iNumMacros - s_iNumMacroFactors)*s_iNumMacroFactors + s_iNumMacroFactors*(s_iNumMacroFactors-1)/2 - 3;
		// vSigma2 parameters for macros
		vRestrictedParms[inc: inc + s_iNumMacros - 1] = exp(vParms[inc: inc + s_iNumMacros - 1]);
		inc += s_iNumMacros;
		// vZc parameters
		inc += s_iNumGrades^2;
		// mZc
		//inc += (s_iNumGrades*s_iNumFactors) - s_iNumFrailtyFactors^2 - s_iNumGrades*s_iNumRecRateFactors;
		inc += s_iNumGrades*s_iNumMacroFactors + s_iNumFrailtyFactors*s_iNumGrades - s_iNumFrailtyFactors*(s_iNumFrailtyFactors + 1)/2 - 5; 
		// dSigma2
		vRestrictedParms[inc] = exp(vParms[inc]);
		inc += 1;
		// vZr
		inc += 1;
		// mZr
		inc += s_iNumFactors - s_iNumRecRateFactors - 1;
		// Dummies
		inc += 2 * s_iNumGrades;
	}
	else if(s_iModel==15)
	{
		// A parameters
		vRestrictedParms[inc : inc + s_iNumFactors - 1] = vParms[inc : inc + s_iNumFactors - 1]/100;
		inc += s_iNumFactors;
		// B parameters
		vRestrictedParms[inc : inc + s_iNumFactors - 1] = 1 ./ (1 + exp(-vParms[inc : inc + s_iNumFactors - 1]));
		inc += s_iNumFactors;
		// mZg
		inc += (s_iNumMacros - s_iNumMacroFactors)*s_iNumMacroFactors + s_iNumMacroFactors*(s_iNumMacroFactors-1)/2;
		// vSigma2 parameters for macros
		vRestrictedParms[inc: inc + s_iNumMacros - 1] = exp(vParms[inc: inc + s_iNumMacros - 1]);
		inc += s_iNumMacros;
		// vZc parameters
		inc += s_iNumGrades^2;
		// mZc
		//inc += (s_iNumGrades*s_iNumFactors) - s_iNumFrailtyFactors^2 - s_iNumGrades*s_iNumRecRateFactors;
		inc += s_iNumGrades*s_iNumMacroFactors + s_iNumFrailtyFactors*s_iNumGrades - s_iNumFrailtyFactors*(s_iNumFrailtyFactors + 1)/2; 
		// dSigma2
		vRestrictedParms[inc] = exp(vParms[inc]);
		inc += 1;
		// vZr
		inc += 1;
		// mZr
		inc += s_iNumFactors - s_iNumRecRateFactors;
		// Dummies
		inc += 2 * s_iNumGrades;
	}
	else if(s_iModel==16)
	{
		// A parameters
		vRestrictedParms[inc : inc + s_iNumFactors - 1] = vParms[inc : inc + s_iNumFactors - 1]/100;
		inc += s_iNumFactors;
		// B parameters
		vRestrictedParms[inc : inc + s_iNumFactors - 1] = 1 ./ (1 + exp(-vParms[inc : inc + s_iNumFactors - 1]));
		inc += s_iNumFactors;
		// mZg
		inc += (s_iNumMacros - s_iNumMacroFactors)*s_iNumMacroFactors + s_iNumMacroFactors*(s_iNumMacroFactors-1)/2;
		// vSigma2 parameters for macros
		vRestrictedParms[inc: inc + s_iNumMacros - 1] = exp(vParms[inc: inc + s_iNumMacros - 1]);
		inc += s_iNumMacros;
		// vZc parameters
		inc += s_iNumGrades^2;
		// mZc
		//inc += (s_iNumGrades*s_iNumFactors) - s_iNumFrailtyFactors^2 - s_iNumGrades*s_iNumRecRateFactors;
		inc += s_iNumGrades*s_iNumMacroFactors + s_iNumFrailtyFactors*s_iNumGrades - s_iNumFrailtyFactors*(s_iNumFrailtyFactors + 1)/2; 
		// dSigma2
		vRestrictedParms[inc] = exp(vParms[inc]);
		inc += 1;
		// vZr
		inc += 1;
		// mZr
		inc += s_iNumFactors - s_iNumRecRateFactors;
		// Dummies
		inc += 2 * s_iNumGrades;
	}
	else if(s_iModel==17)
	{
		// A parameters
		vRestrictedParms[inc : inc + s_iNumFactors - 1] = vParms[inc : inc + s_iNumFactors - 1]/100;
		inc += s_iNumFactors;
		// B parameters
		vRestrictedParms[inc : inc + s_iNumFactors - 1] = 1 ./ (1 + exp(-vParms[inc : inc + s_iNumFactors - 1]));
		inc += s_iNumFactors;
		// mZg
		inc += (s_iNumMacros - s_iNumMacroFactors)*s_iNumMacroFactors + s_iNumMacroFactors*(s_iNumMacroFactors-1)/2;
		// vSigma2 parameters for macros
		vRestrictedParms[inc: inc + s_iNumMacros - 1] = exp(vParms[inc: inc + s_iNumMacros - 1]);
		inc += s_iNumMacros;
		// vZc parameters
		inc += s_iNumGrades^2;
		// mZc
		//inc += (s_iNumGrades*s_iNumFactors) - s_iNumFrailtyFactors^2 - s_iNumGrades*s_iNumRecRateFactors;
		inc += s_iNumGrades*s_iNumMacroFactors + s_iNumFrailtyFactors*s_iNumGrades - s_iNumFrailtyFactors*(s_iNumFrailtyFactors + 1)/2; 
		// dSigma2
		vRestrictedParms[inc] = exp(vParms[inc]);
		inc += 1;
		// vZr
		inc += 1;
		// mZr
		inc += s_iNumFactors - s_iNumRecRateFactors;
		// Dummies
		inc += 2 * s_iNumGrades;
	}
	
	return vRestrictedParms;
}

getStartingValues()
{
	decl vParms = 0;

	if(s_iModel==1)
	{
		s_iNumMacros = 0;//rows(s_mYg);
		s_iNumMacroFactors = 0;
		s_iNumGrades = 4;
		s_iNumTransitionTypes = rows(s_mYc);
		s_iNumFrailtyFactors = 2;
		s_iNumRecRateFactors = 0;
		s_iNumRecRates = 0;
		s_iNumIndustries = 1;
		s_iNumIndustriesLGD = 1;
		vParms = 7.1201 | 6.87917 | 3.13116 | 2.75843 | 6.16654 | 8.15485 | 9.49296 | 10.1595 | -5.21225 | 4.59991 | 7.02591 | 7.42271 | -7.61487 | -5.43443 | 4.65722 | 5.9826 | -8.89283 | -7.97567 | -5.16297 | 3.87423 | 0.373823 | 0.949294 | 1.98701 | -0.700717 | 3.75088 | 1.60108 | -3.08261 | -2.64817 | -0.612389 | 1.62925 | -0.921363 | -3.15917 ; 
		vParms = 6.70276 | 12.7607 | 2.82683 | 3.01781 | 6.16372 | 8.1521 | 9.49023 | 10.1568 | -5.20823 | 4.61568 | 7.04169 | 7.4385 | -7.61966 | -5.43921 | 4.6492 | 5.97457 | -8.94202 | -8.02487 | -5.21203 | 3.84877 | 1.41674 | -0.201592 | 1.15186 | 0.0816697 | 3.78668 | 1.73117 | -3.03384 | -3.16965 | -0.978246 | 1.67446 | -0.937019 | -2.98635 ;
		s_vParmsOrig = fabs(vParms);
		s_vParmsOrig = exp(round( 10* log(s_vParmsOrig) ) / 10 );
		vParms = 2 * (vParms .> 0) - 1;
	
	}
	else if(s_iModel==2)
	{
		s_iNumMacros = rows(s_mYg);
		s_iNumMacroFactors = 3;
		s_iNumGrades = 4;
		s_iNumTransitionTypes = rows(s_mYc);
		s_iNumFrailtyFactors = 2;
		s_iNumRecRateFactors = 0;
		s_iNumRecRates = 0;
		s_iNumIndustries = 1;
		s_iNumIndustriesLGD = 1;
		//vParms = 24.7205 | 28.6792 | 31.1088 | 3.88067 | 7.65449 | 3.3981 | 2.84557 | 2.00035 | 3.1767 | 4.1685 | -0.873441 | 0.144993 | -0.0211384 | 0.827105 | -0.0642953 | 0.28958 | 0.0701854 | -0.720409 | 1.09788 | -2.72452 | -2.16265 | -1.26812 | -2.87543 | -1.66507 | -0.6045 | 6.17605 | 8.16448 | 9.50262 | 10.1692 | -5.19342 | 4.62968 | 7.0557 | 7.45251 | -7.6097 | -5.42927 | 4.67015 | 5.99595 | -8.82674 | -7.90958 | -5.0966 | 3.99605 | 0.0253777 | 0.271162 | -0.0878833 | 1.83411 | -0.208074 | -0.0586053 | 0.179541 | -0.0665136 | -0.162938 | 0.210237 | -0.103138 | 0.789484 | 0.101536 | -0.272892 | 0.100414 | -0.0160125 | 3.59432 | 1.45743 | -3.5947 | -3.37257 | -0.963314 | 1.66362 | -0.951105 | -2.97084 ;		 
		vParms = 24.7205 | 28.6792 | 31.1088 | 3.88067 | 7.65449 | 3.3981 | 2.84557 | 2.00035 | 3.1767 | 4.1685 | -0.873441 | 0.144993 | -0.0211383 | 0.827105 | -0.0642955 | 0.28958 | 0.0701851 | -0.72041 | 1.09788 | -2.72452 | -2.16265 | -1.26812 | -2.87543 | -1.66508 | -0.6045 | 6.17605 | 8.16448 | 9.50262 | 10.1692 | -5.19342 | 4.62968 | 7.0557 | 7.45251 | -7.6097 | -5.42927 | 4.67015 | 5.99595 | -8.82674 | -7.90958 | -5.0966 | 3.99604 | 0.025378 | 0.271162 | -0.0878833 | 1.8341 | -0.208073 | -0.0586052 | 0.179541 | -0.0665137 | -0.162938 | 0.210237 | -0.103138 | 0.789483 | 0.101536 | -0.272892 | 0.100414 | -0.0160117 | 3.59432 | 1.45743 | -3.5947 | -3.37257 | -0.963314 | 1.66362 | -0.951105 | -2.97084 ;
		s_vParmsOrig = fabs(vParms);
		s_vParmsOrig = exp(round( 10* log(s_vParmsOrig) ) / 10 );
		vParms = 2 * (vParms .> 0) - 1;
	
	}
	else if(s_iModel==3)
	{
		s_iNumMacros = rows(s_mYg);
		s_iNumMacroFactors = 2;
		s_iNumGrades = 4;
		s_iNumTransitionTypes = rows(s_mYc);
		s_iNumFrailtyFactors = 0;
		s_iNumRecRateFactors = 0;
		s_iNumRecRates = 1;
		s_iNumIndustries = 1;
		s_iNumIndustriesLGD = 1;
		vParms = 24.5894 | 30.9674 | 3.39819 | 2.70864 | -0.881857 | 0.128278 | 0.818634 | -0.0151499 | 0.0699152 | -0.570582 | 0.118295 | 0.353306 | -2.73416 | -2.13189 | -1.127 | -2.85895 | -0.368608 | -0.0643504 | 6.12194 | 8.11021 | 9.44832 | 10.1148 | -5.20876 | 4.57099 | 6.99652 | 7.3933 | -7.62184 | -5.44151 | 4.61044 | 5.93595 | -8.63062 | -7.71339 | -4.90073 | 3.98425 | 0.00285125 | 0.248312 | -0.0909053 | 0.139103 | -0.157323 | 0.176284 | -0.123345 | 0.112684 | 0.833664 | 0.252961 | 0.0010484 | 0.124527 | 3.13975 | 1.19986 | -3.68184 | -3.11517 | -0.812248 | 1.62066 | -1.01826 | -3.45877
		| 0;		 
//		s_vParmsOrig = fabs(vParms);
//		s_vParmsOrig = exp(round( 10* log(s_vParmsOrig) ) / 10 );
//		vParms = 2 * (vParms .> 0) - 1;
	}
	else if(s_iModel==4)
	{
		s_iNumMacros = rows(s_mYg);
		s_iNumMacroFactors = 2;
		s_iNumGrades = 4;
		s_iNumTransitionTypes = rows(s_mYc);
		s_iNumFrailtyFactors = 1;
		s_iNumRecRateFactors = 0;
		s_iNumRecRates = 1;
		s_iNumIndustries = 1;
		s_iNumIndustriesLGD = 1;
		vParms = 24.7087 | 31.2795 | 3.09814 | 3.39032 | 2.77006 | 3.92564 | -0.877712 | 0.136292 | 0.815585 | -0.0285435 | 0.0691691 | -0.569609 | 0.114239 | 0.352849 | -2.71916 | -2.15374 | -1.1396 | -2.84546 | -0.365974 | -0.0656184 | 6.16038 | 8.14872 | 9.48684 | 10.1534 | -5.19824 | 4.62193 | 7.04794 | 7.44475 | -7.64426 | -5.46385 | 4.63267 | 5.95849 | -8.84795 | -7.93074 | -5.11772 | 3.95665 | 0.0181981 | 0.296162 | 1.05988 | -0.0590309 | 0.196389 | -0.163325 | 0.200297 | 0.973716 | -0.242488 | 0.0756861 | 2.44399 | 0.9305 | 0.0850951 | 0.0332581 | 0.261005 | 1.65162 | 3.34523 | 1.42768 | -3.53786 | -2.87762 | -0.591462 | 1.87839 | -0.861708 | -3.19721
				| 0;
//		s_vParmsOrig = fabs(vParms);
//		s_vParmsOrig = exp(round( 10* log(s_vParmsOrig) ) / 10 );
//		vParms = 2 * (vParms .> 0) - 1;	
	}
	else if(s_iModel==5)
	{
		s_iNumMacros = rows(s_mYg);
		s_iNumMacroFactors = 2;
		s_iNumGrades = 4;
		s_iNumTransitionTypes = rows(s_mYc);
		s_iNumFrailtyFactors = 2;
		s_iNumRecRateFactors = 0;
		s_iNumRecRates = 1;
		s_iNumIndustries = 1;
		s_iNumIndustriesLGD = 1;
		vParms = 24.6915 | 31.7236 | 4.05781 | 7.18835 | 3.38955 | 2.78833 | 3.27815 | 4.08882 | -0.870042 | 0.14403 | 0.811164 | -0.0324143 | 0.0779145 | -0.558207 | 0.130396 | 0.373419 | -2.74036 | -2.13892 | -1.14708 | -2.84313 | -0.358903 | -0.0719217 | 6.25951 | 8.24794 | 9.58608 | 10.2526 | -5.20001 | 4.62532 | 7.05137 | 7.44818 | -7.64775 | -5.46732 | 4.63107 | 5.95684 | -9.15413 | -8.23696 | -5.42392 | 3.67004 | 0.0234533 | 0.233138 | 1.79386 | -0.347939 | -0.050007 | 0.169064 | -0.161777 | 0.1854 | 0.833425 | 0.0841661 | -0.260495 | 0.0595987 | 0.938999 | 0.242194 | 0.0196294 | 0.264699 | 0.179825 | 0.718084 | 3.69569 | 1.49901 | -3.52591 | -3.56189 | -1.0854 | 1.67147 | -0.977354 | -2.99023 ;
	    vParms = 24.6915 | 31.7236 | 4.05782 | 7.18835 | 3.38955 | 2.78833 | 3.27815 | 4.08881 | -0.870042 | 0.14403 | 0.811164 | -0.0324146 | 0.0779148 | -0.558206 | 0.130396 | 0.373419 | -2.74036 | -2.13892 | -1.14708 | -2.84313 | -0.358903 | -0.0719217 | 6.25951 | 8.24794 | 9.58608 | 10.2526 | -5.20001 | 4.62532 | 7.05137 | 7.44818 | -7.64775 | -5.46732 | 4.63107 | 5.95684 | -9.15414 | -8.23696 | -5.42392 | 3.67004 | 0.0234534 | 0.233138 | 1.79386 | -0.347939 | -0.050007 | 0.169064 | -0.161777 | 0.1854 | 0.833425 | 0.0841661 | -0.260494 | 0.0595987 | 0.938999 | 0.242194 | 0.0196292 | 0.264699 | 0.179827 | 0.718083 | 3.69569 | 1.49901 | -3.52591 | -3.56189 | -1.0854 | 1.67147 | -0.977354 | -2.99023
		| 0 | 0;
//		s_vParmsOrig = fabs(vParms);
//		s_vParmsOrig = exp(round( 10* log(s_vParmsOrig) ) / 10 );
//		vParms = 2 * (vParms .> 0) - 1;	
	}
	else if(s_iModel==6)
	{
		s_iNumMacros = rows(s_mYg);
		s_iNumMacroFactors = 3;
		s_iNumGrades = 4;
		s_iNumTransitionTypes = rows(s_mYc);
		s_iNumFrailtyFactors = 0;
		s_iNumRecRateFactors = 0;
		s_iNumRecRates = 1;
		s_iNumIndustries = 1;
		s_iNumIndustriesLGD = 1;
		vParms = 24.8112 | 28.3269 | 31.5847 |
		         3.40938 | 2.82884 | 1.9923 | 
				 -0.879895 | 0.137314 | -0.0144978 | 0.830202 | -0.0646282 | 0.286152 | 0.073064 | -0.720676 | 1.08749 |
				 -2.7038 | -2.1699 | -1.26213 | -2.89471 | -1.66798 | -0.616059 |
				 6.23999 | 8.22834 | 9.56646 | 10.233 | -5.20306 | 4.6168 | 7.04289 | 7.43969 | -7.607 | -5.42656 | 4.67477 | 6.00058 | -8.76333 | -7.84615 | -5.03316 | 4.05951 |
				 -0.0221818 | 0.313246 | -0.14318 | 
				 -0.0274516 | -0.145783 | 0.212157 |
				 -0.104712 | 0.262231 | 0.792322 | 
				 0.0152813 | 0.24131 | 0.344977 |
				 0.940247 |
				  0.172364 |
				  0.0227537 | 0.287128 | -0.0569848 | 
				 3.21807 | 1.41808 | -3.58579 | -2.8436 | -0.496718 | 1.76977 | -0.904057 | -3.11629 ;
		vParms = 24.5986 | 27.7311 | 30.0332 | 3.39919 | 2.80618 | 2.06523 | -0.880341 | 0.134526 | -0.0106086 | 0.82865 | -0.0496472 | 0.280957 | 0.0783343 | -0.701627 | 1.08843 | -2.7222 | -2.16105 | -1.23937 | -2.918 | -1.67504 | -0.612246 | 6.12668 | 8.11497 | 9.45307 | 10.1196 | -5.21135 | 4.57124 | 6.99683 | 7.39362 | -7.62354 | -5.44318 | 4.61701 | 5.94256 | -8.62887 | -7.71164 | -4.899 | 3.98558 | 0.0098958 | 0.272361 | -0.128886 | -0.0882856 | 0.151807 | -0.0940765 | -0.151625 | 0.19482 | -0.149815 | -0.127937 | 0.111733 | -0.0467363 | 0.836949 | 0.2481 | -0.000336592 | 0.132476 | -0.134483 | 3.05924 | 1.13683 | -3.78406 | -3.1422 | -0.796688 | 1.61919 | -1.02771 | -3.45621
|0 | 0 | 0		; 		 
//		s_vParmsOrig = fabs(vParms);
//		s_vParmsOrig = exp(round( 10* log(s_vParmsOrig) ) / 10 );
//		vParms = 2 * (vParms .> 0) - 1;	
	}
	else if(s_iModel==7)
	{
		s_iNumMacros = rows(s_mYg);
		s_iNumMacroFactors = 3;
		s_iNumGrades = 4;
		s_iNumTransitionTypes = rows(s_mYc);
		s_iNumFrailtyFactors = 1;
		s_iNumRecRateFactors = 0;
		s_iNumRecRates = 1;
		s_iNumIndustries = 1;
		s_iNumIndustriesLGD = 1;
		vParms = 24.7422 | 27.9598 | 31.2306 | 2.89485 | 3.3888 | 2.86176 | 2.00315 | 4.00191 | -0.87628 | 0.14268 | -0.0175911 | 0.825716 | -0.0681011 | 0.282521 | 0.076144 | -0.715624 | 1.08796 | -2.7099 | -2.17312 | -1.25981 | -2.89653 | -1.67186 | -0.615941 | 6.1663 | 8.15466 | 9.49278 | 10.1593 | -5.19692 | 4.62239 | 7.04841 | 7.44523 | -7.64255 | -5.46213 | 4.63659 | 5.96244 | -8.87055 | -7.95335 | -5.14029 | 3.94481 | 0.0197227 | 0.322507 | -0.106109 | 1.081 | -0.0626799 | 0.208921 | -0.0659653 | -0.162657 | 0.219864 | -0.119353 | 0.979615 | -0.265868 | 0.0725039 | 0.0417999 | 2.6158 | 0.928537 | 0.0845597 | 0.0252537 | 0.269973 | -0.0395765 | 1.70998 | 3.27085 | 1.37435 | -3.6324 | -2.85557 | -0.561395 | 1.89124 | -0.859826 | -3.15311 
		|0 | 0 | 0		; 		 
//		s_vParmsOrig = fabs(vParms);
//		s_vParmsOrig = exp(round( 10* log(s_vParmsOrig) ) / 10 );
//		vParms = 2 * (vParms .> 0) - 1;	
	}
	else if(s_iModel==8)
	{
		s_iNumMacros = rows(s_mYg);
		s_iNumMacroFactors = 3;
		s_iNumGrades = 4;
		s_iNumTransitionTypes = rows(s_mYc);
		s_iNumFrailtyFactors = 1;
		s_iNumRecRateFactors = 1;
		s_iNumRecRates = 1;
		s_iNumIndustries = 1;
		s_iNumIndustriesLGD = 1;
		vParms = 24.7422 | 27.9598 | 31.2306 | 2.89485 |  2.2 |
		          3.3888 | 2.86176 | 2.00315 | 4.00191 | 3.0 |
				  -0.87628 | 0.14268 | -0.0175911 | 0.825716 | -0.0681011 | 0.282521 | 0.076144 | -0.715624 | 1.08796 |
				  -2.7099 | -2.17312 | -1.25981 | -2.89653 | -1.67186 | -0.615941 |
				  6.1663 | 8.15466 | 9.49278 | 10.1593 | -5.19692 | 4.62239 | 7.04841 | 7.44523 | -7.64255 | -5.46213 | 4.63659 | 5.96244 | -8.87055 | -7.95335 | -5.14029 | 3.94481 |
				  0.0197227 | 0.322507 | -0.106109 | 1.081 |
				  -0.0626799 | 0.208921 | -0.0659653 |
				  -0.162657 | 0.219864 | -0.119353 | 0.979615 |
				  -0.265868 | 0.0725039 | 0.0417999 | 2.6158 |
				  0.928537 | 0.0845597 | 0.0252537 | 0.269973 | -0.0395765 | 1.70998 |
				  3.27085 | 1.37435 | -3.6324 | -2.85557 | -0.561395 | 1.89124 | -0.859826 | -3.15311 ;
		vParms = 24.825 | 27.9439 | 31.1341 | 2.80528 | 3.08197 | 3.40795 | 2.85372 | 2.005 | 3.90113 | 3.28508 | -0.879741 | 0.139773 | -0.0173205 | 0.825896 | -0.0694181 | 0.281744 | 0.0790919 | -0.712235 | 1.08831 | -2.69272 | -2.18599 | -1.25866 | -2.8967 | -1.67324 | -0.615004 | 6.19854 | 8.18691 | 9.52504 | 10.1916 | -5.17472 | 4.64424 | 7.07024 | 7.46706 | -7.61888 | -5.43846 | 4.6607 | 5.98654 | -8.79997 | -7.88276 | -5.06975 | 4.00865 | 0.0204803 | 0.32684 | -0.10944 | 1.20205 | -0.0651221 | 0.204972 | -0.07115 | -0.162426 | 0.220022 | -0.119985 | 1.02616 | -0.263918 | 0.0767803 | 0.0491797 | 2.80378 | 0.935943 | 0.134511 | 0.0241646 | 0.281346 | -0.0505372 | 1.49029 | 3.31667 | 1.38772 | -3.60431 | -2.74749 | -0.550303 | 1.86422 | -0.872729 | -3.1681
		|0 | 0 | 0		; 		 
//		s_vParmsOrig = fabs(vParms);
//		s_vParmsOrig = exp(round( 10* log(s_vParmsOrig) ) / 10 );
//		vParms = 2 * (vParms .> 0) - 1;	
	}
	else if(s_iModel==9)
	{
		s_iNumMacros = rows(s_mYg);
		s_iNumMacroFactors = 3;
		s_iNumGrades = 4;
		s_iNumTransitionTypes = rows(s_mYc);
		s_iNumFrailtyFactors = 2;
		s_iNumRecRateFactors = 0;
		s_iNumRecRates = 1;
		s_iNumIndustries = 1;
		s_iNumIndustriesLGD = 1;
		vParms = 24.6683 | 28.1636 | 31.1834 | 3.87526 | 7.28728 | 3.38674 | 2.87721 | 1.99982 | 3.23658 | 4.05261 | -0.868563 | 0.150471 | -0.0220673 | 0.820667 | -0.0732521 | 0.289965 | 0.0712076 | -0.7205 | 1.09539 | -2.73747 | -2.15326 | -1.26944 | -2.89526 | -1.66465 | -0.605693 | 6.26611 | 8.25454 | 9.59268 | 10.2592 | -5.20113 | 4.62353 | 7.04958 | 7.44639 | -7.6527 | -5.47227 | 4.62756 | 5.95335 | -9.15415 | -8.23698 | -5.42394 | 3.67043 | 0.00916373 | 0.259504 | -0.101328 | 1.90594 | -0.370807 | -0.0590217 | 0.181688 | -0.0643624 | -0.164323 | 0.203748 | -0.0996745 | 0.799514 | 0.0955691 | -0.263086 | 0.0542197 | -0.00462188 | 0.938388 | 0.25222 | 0.024404 | 0.268918 | -0.00762516 | 0.0842076 | 0.745098 | 3.64556 | 1.44977 | -3.61596 | -3.55041 | -1.06708 | 1.69203 | -0.950369 | -2.98292
		| 0 | 0 | 0 | 0;
		vParms = 23.7534 | 31.248 | 27.3088 | 3.29413 | 3.66155 | 3.47959 | 2.82703 | 2.16579 | 3.77849 | 3.58857 | -0.888072 | 0.124745 | -0.0666055 | 0.806817 | 0.0619168 | 0.33318 | 0.0523619 | -0.277577 | 1.22173 | -2.7764 | -2.1163 | -1.27597 | -2.82997 | -1.87501 | -0.664099 | 6.28881 | 8.27725 | 9.61539 | 10.2819 | -5.20269 | 4.62063 | 7.04669 | 7.4435 | -7.64006 | -5.45963 | 4.6416 | 5.96742 | -9.00621 | -8.08902 | -5.27596 | 3.81987 | -0.0537736 | 0.192435 | -0.125405 | 1.48726 | -1.14907 | -0.078094 | 0.165634 | -0.101917 | -0.184503 | 0.157038 | -0.139558 | 0.977172 | -0.0144951 | -0.259133 | 0.0680954 | -0.0206376 | 0.939986 | 0.189639 | 0.00963758 | 0.258271 | -0.0831821 | 1.22141 | 1.02158 | 3.6144 | 1.34975 | -3.64171 | -3.21878 | -1.10458 | 1.81415 | -0.932476 | -3.05319 | -0.172389 | -0.00905792 | 0.644988 | 1.91607 ;
//		s_vParmsOrig = fabs(vParms);
//		s_vParmsOrig = exp(round( 10* log(s_vParmsOrig) ) / 10 );
//		vParms = 2 * (vParms .> 0) - 1;
	}
	else if(s_iModel==10)
	{
		s_iNumMacros = rows(s_mYg);
		s_iNumMacroFactors = 3;
		s_iNumGrades = 4;
		s_iNumTransitionTypes = rows(s_mYc);
		s_iNumFrailtyFactors = 2;
		s_iNumRecRateFactors = 1;
		s_iNumRecRates = 1;
		s_iNumIndustries = 1;
		s_iNumIndustriesLGD = 1;
		vParms = 24.6786 | 28.3302 | 31.1837 | 3.80953 | 7.06621 | 1.45163 | 3.3933 | 2.87109 | 1.9997 | 3.2198 | 4.05375 | 2.56511 | -0.869377 | 0.149644 | -0.021582 | 0.820425 | -0.0741308 | 0.289297 | 0.0695527 | -0.722049 | 1.09459 | -2.73301 | -2.1564 | -1.26901 | -2.88784 | -1.66273 | -0.607378 | 6.20156 | 8.19 | 9.52813 | 10.1947 | -5.19568 | 4.62836 | 7.0544 | 7.4512 | -7.62862 | -5.44819 | 4.65174 | 5.97753 | -8.9835 | -8.06634 | -5.25332 | 3.84315 | 0.0186545 | 0.261287 | -0.0937368 | 1.89251 | -0.300156 | -0.0607944 | 0.179902 | -0.0639306 | -0.166201 | 0.20391 | -0.0997542 | 0.824823 | 0.0836718 | -0.281799 | 0.0658952 | -0.0126891 | 0.940768 | 0.12945 | 0.0428767 | 0.286292 | -0.00135262 | 0.270103 | 0.638863 | 3.61888 | 1.45252 | -3.5968 | -3.48125 | -1.03126 | 1.67947 | -0.965284 | -2.98787
		| 0 | 0 | 0 | 0;		 
//		s_vParmsOrig = fabs(vParms);
//		s_vParmsOrig = exp(round( 10* log(s_vParmsOrig) ) / 10 );
//		vParms = 2 * (vParms .> 0) - 1;
	}
	else if(s_iModel==11)
	{
		s_iNumMacros = rows(s_mYg);
		s_iNumMacroFactors = 4;
		s_iNumGrades = 4;
		s_iNumTransitionTypes = rows(s_mYc);
		s_iNumFrailtyFactors = 0;
		s_iNumRecRateFactors = 0;
		s_iNumRecRates = 1;
		s_iNumIndustries = 1;
		s_iNumIndustriesLGD = 1;
	    vParms = 21.3536 | 14.0022 | 29.7467 | 27.3134 |
		         3.34538 | 3.66035 | 2.30488 | 2.22302 |
				 -0.545103 |
				 0.737872 | -0.25186 | 0.128875 | 0.309953 |
				 -0.238692 | 0.240896 |
				 0.0712643 | -0.277035 | -0.249175 | 1.17338 |
				 0.149457 | 0.51952 | 0.591011 |
				 -3.00768 | -2.9906 | -1.29657 | -2.87243 | -1.85954 | -0.684738 |
				 6.12854 | 8.11683 | 9.45494 | 10.1215 | -5.21218 | 4.57323 | 6.99888 | 7.39567 | -7.62418 | -5.44381 | 4.62067 | 5.94627 | -8.64884 | -7.73165 | -4.91902 | 3.98703 |
				 -0.154774 | -0.221067 | 0.230913 | -0.186431 | -0.0692993 | 0.136426 | 0.0996992 | -0.124564 | -0.144804 | 0.130981 | 0.115781 | -0.184879 | 0.0810582 | 0.434706 | 0.0435294 | -0.147845 |
				 0.845444 | 0.236661 |
				 0.0832112 | 0.1929 | 0.0950492 | -0.156817 |
				 2.99304 | 1.14656 | -3.76489 | -3.08279 |
				 -1.02227 | 1.62841 | -1.05111 | -3.2963 ;
		//vParms = 21.3536 | 14.0022 | 29.7467 | 27.3134 | 3.34538 | 3.66035 | 2.30488 | 2.22302 | -0.545103 | 0.737872 | -0.25186 | 0.128875 | 0.309953 | -0.238692 | 0.240896 | 0.0712643 | -0.277035 | -0.249175 | 1.17338 | 0.149457 | 0.51952 | 0.591011 | -3.00768 | -2.9906 | -1.29657 | -2.87243 | -1.85954 | -0.684738 | 6.12854 | 8.11683 | 9.45494 | 10.1215 | -5.21218 | 4.57323 | 6.99888 | 7.39567 | -7.62418 | -5.44381 | 4.62067 | 5.94627 | -8.64884 | -7.73165 | -4.91902 | 3.98703 | -0.154774 | -0.221067 | 0.230913 | -0.186431 | -0.0692993 | 0.136426 | 0.0996992 | -0.124564 | -0.144804 | 0.130981 | 0.115781 | -0.184879 | 0.0810582 | 0.434706 | 0.0435294 | -0.147845 | 0.845444 | 0.236661 | 0.0832112 | 0.1929 | 0.0950492 | -0.156817 | 2.99304 | 1.14656 | -3.76489 | -3.08279 | -1.02227 | 1.62841 | -1.05111 | -3.2963 |  

//		s_vParmsOrig = fabs(vParms);
//		s_vParmsOrig = exp(round( 10* log(s_vParmsOrig) ) / 10 );
//		vParms = 2 * (vParms .> 0) - 1;
	}
	else if(s_iModel==12)
	{
		s_iNumMacros = rows(s_mYg);
		s_iNumMacroFactors = 4;
		s_iNumGrades = 4;
		s_iNumTransitionTypes = rows(s_mYc);
		s_iNumFrailtyFactors = 1;
		s_iNumRecRateFactors = 0;
		s_iNumRecRates = 1;
		s_iNumIndustries = 1;
		s_iNumIndustriesLGD = 1;
        vParms = 22.0712 | 15.0622 | 29.8689 | 28.1174 | 2.5 |
		         3.33974 | 3.67883 | 2.38706 | 2.15467 | 3.2 |
				-0.47138 | 0.70725 | -0.284949 | 0.113898 | 0.315025 | -0.264391 | 0.149162 | 0.029243 | -0.356372 | -0.256962 | 1.18694 | 0.12588 | 0.358236 | 0.588347 | -3.01592 | -3.02053 | -1.32385 | -2.85637 | -1.87467 | -0.671923 | 6.29634 | 8.28477 | 9.6229 | 10.2894 | -5.19712 | 4.63031 | 7.05644 | 7.45326 | -7.64678 | -5.46634 | 4.63657 | 5.96241 | -9.087 | -8.16981 | -5.35677 | 3.73612 |
				-0.0968084 | -0.0521935 | 0.219946 | -0.115625 | 0 |
				-0.0182739 | 0.199857 | 0.147755 | -0.0804672 | 0 |
				-0.167167 | 0.12423 | 0.146607 | -0.127139 | 0 |
				-0.271462 | 0.0398214 | 0.0642127 |
				-0.0101179 | 0.943977 | 0.239996 |
				0.0152956 | 0.114314 | 0.268984 | -0.0874918 | 0 |
			3.59391 | 1.47809 | -3.62299 | -3.36064 | -1.16639 | 1.81208 | -0.952314 | -3.06049 ;
//		s_vParmsOrig = fabs(vParms);
//		s_vParmsOrig = exp(round( 10* log(s_vParmsOrig) ) / 10 );
//		vParms = 2 * (vParms .> 0) - 1;
	}
	else if(s_iModel==13)
	{
		s_iNumMacros = rows(s_mYg);
		s_iNumMacroFactors = 4;
		s_iNumGrades = 4;
		s_iNumTransitionTypes = rows(s_mYc);
		s_iNumFrailtyFactors = 2;
		s_iNumRecRateFactors = 0;
		s_iNumRecRates = 1;
		s_iNumIndustries = 1;
		s_iNumIndustriesLGD = 1;
		vParms = 23.7534 | 31.248 | 31.248 | 27.3088 | 3.29413 | 3.66155 |
		         3.47959 | 2.82703 | 2.82703 | 2.16579 | 3.77849 | 3.58857 |
				 zeros(14,1) | 
				 -2.7764 | -2.1163 | -1.27597 | -2.82997 | -1.87501 | -0.664099 |
				 6.28881 | 8.27725 | 9.61539 | 10.2819 | -5.20269 | 4.62063 | 7.04669 | 7.4435 | -7.64006 | -5.45963 | 4.6416 | 5.96742 | -9.00621 | -8.08902 | -5.27596 | 3.81987 |
				 zeros(21,1) | 
				 //-0.0537736 | 0.192435 | -0.125405 | 1.48726 | -1.14907 | -0.078094 | 0.165634 | -0.101917 | -0.184503 | 0.157038 | -0.139558 | 0.977172 | -0.0144951 | -0.259133 | 0.0680954 | -0.0206376 |
				 0.939986 | 0.189639 | 0.00963758 | 0 | 0.258271 | -0.0831821 | 1.22141 | 1.02158 |
				 3.6144 | 1.34975 | -3.64171 | -3.21878 | -1.10458 | 1.81415 | -0.932476 | -3.05319 ;
		vParms = 22.0712 | 15.0622 | 29.8689 | 28.1174 | 3.74136 | 4.55317 | 3.33974 | 3.67883 | 2.38706 | 2.15467 | 3.54953 | 3.97972 | -0.47138 | 0.70725 | -0.284949 | 0.113898 | 0.315025 | -0.264391 | 0.149162 | 0.029243 | -0.356372 | -0.256962 | 1.18694 | 0.12588 | 0.358236 | 0.588347 | -3.01592 | -3.02053 | -1.32385 | -2.85637 | -1.87467 | -0.671923 | 6.29634 | 8.28477 | 9.6229 | 10.2894 | -5.19712 | 4.63031 | 7.05644 | 7.45326 | -7.64678 | -5.46634 | 4.63657 | 5.96241 | -9.087 | -8.16981 | -5.35677 | 3.73612 | -0.0968084 | -0.0521935 | 0.219946 | -0.115625 | 1.51408 | -0.613568 | -0.0182739 | 0.199857 | 0.147755 | -0.0804672 | -0.167167 | 0.12423 | 0.146607 | -0.127139 | 0.87837 | 0.0687862 | -0.271462 | 0.0398214 | 0.0642127 | -0.0101179 | 1.43544 | 0.943977 | 0.239996 | 0.0152956 | 0.114314 | 0.268984 | -0.0874918 | 0.883316 | 0.896523 | 3.59391 | 1.47809 | -3.62299 | -3.36064 | -1.16639 | 1.81208 | -0.952314 | -3.06049 ;
//		s_vParmsOrig = fabs(vParms);
//		s_vParmsOrig = exp(round( 10* log(s_vParmsOrig) ) / 10 );
//		vParms = 2 * (vParms .> 0) - 1;
	}
	else if(s_iModel==14)
	{
		s_iNumMacros = rows(s_mYg);
		s_iNumMacroFactors = 4;
		s_iNumGrades = 4;
		s_iNumTransitionTypes = rows(s_mYc);
		s_iNumFrailtyFactors = 2;
		s_iNumRecRateFactors = 0;
		s_iNumRecRates = 1;
		s_iNumIndustries = 1;
		s_iNumIndustriesLGD = 1;
		vParms = 22.1332 | 15.4302 | 29.9498 | 28.2276 | 3.68184 | 4.38538 | 3.33901 | 3.63079 | 2.50358 | 2.14791 | 3.63424 | 3.92879 | -0.467491 | 0.674954 | -0.265737 | 0.295467 | -0.274867 | -0.358429 | -0.292531 | 1.17855 | 0.101655 | 0.245904 | 0.563764 | -3.01734 | -3.01008 | -1.31942 | -2.85369 | -1.86795 | -0.679553 | 6.2999 | 8.28834 | 9.62647 | 10.293 | -5.19679 | 4.62988 | 7.056 | 7.45282 | -7.63564 | -5.45519 | 4.64784 | 5.97368 | -9.07077 | -8.15358 | -5.34054 | 3.75177 | -0.0644272 | 0.217893 | -0.110026 | 1.52012 | -0.726666 | 0.203855 | 0.158585 | -0.0772621 | -0.153727 | 0.129657 | 0.150158 | -0.121427 | 0.914058 | -0.28285 | 0.0755538 | 1.48656 | 0.944716 | 0.22574 | 0.0527234 | 0.274485 | -0.0774273 | 0.938189 | 0.913394 | 3.60743 | 1.47236 | -3.59959 | -3.36633 | -1.1639 | 1.84661 | -0.967946 | -3.06376 ;		 
//		s_vParmsOrig = fabs(vParms);
//		s_vParmsOrig = exp(round( 10* log(s_vParmsOrig) ) / 10 );
//		vParms = 2 * (vParms .> 0) - 1;
	}
	else if(s_iModel==15)
	{
		s_iNumMacros = rows(s_mYg);
		s_iNumMacroFactors = 4;
		s_iNumGrades = 4;
		s_iNumTransitionTypes = rows(s_mYc);
		s_iNumFrailtyFactors = 2;
		s_iNumRecRateFactors = 1;
		s_iNumRecRates = 1;
		s_iNumIndustries = 1;
		s_iNumIndustriesLGD = 1;
		vParms = 22.0712 | 15.0622 | 29.8689 | 28.1174 | 3.74136 | 4.55317 | 4.55317 |
		         3.33974 | 3.67883 | 2.38706 | 2.15467 | 3.54953 | 3.97972 | 3.97972 |
				  -0.47138 | 0.70725 | -0.284949 | 0.113898 | 0.315025 | -0.264391 | 0.149162 | 0.029243 | -0.356372 | -0.256962 | 1.18694 | 0.12588 | 0.358236 | 0.588347 | -3.01592 | -3.02053 | -1.32385 | -2.85637 | -1.87467 | -0.671923 | 6.29634 | 8.28477 | 9.6229 | 10.2894 | -5.19712 | 4.63031 | 7.05644 | 7.45326 | -7.64678 | -5.46634 | 4.63657 | 5.96241 | -9.087 | -8.16981 | -5.35677 | 3.73612 | -0.0968084 | -0.0521935 | 0.219946 | -0.115625 | 1.51408 | -0.613568 | -0.0182739 | 0.199857 | 0.147755 | -0.0804672 | -0.167167 | 0.12423 | 0.146607 | -0.127139 | 0.87837 | 0.0687862 | -0.271462 | 0.0398214 | 0.0642127 | -0.0101179 | 1.43544 | 0.943977 | 0.239996 | 0.0152956 | 0.114314 | 0.268984 | -0.0874918 | 0.883316 | 0.896523 | 3.59391 | 1.47809 | -3.62299 | -3.36064 | -1.16639 | 1.81208 | -0.952314 | -3.06049 ;
//		s_vParmsOrig = fabs(vParms);
//		s_vParmsOrig = exp(round( 10* log(s_vParmsOrig) ) / 10 );
//		vParms = 2 * (vParms .> 0) - 1;
	}
	else if(s_iModel==16)
	{
		s_iNumMacros = rows(s_mYg);
		s_iNumMacroFactors = 5;
		s_iNumGrades = 4;
		s_iNumTransitionTypes = rows(s_mYc);
		s_iNumFrailtyFactors = 1;
		s_iNumRecRateFactors = 0;
		s_iNumRecRates = 1;
		s_iNumIndustries = 1;
		s_iNumIndustriesLGD = 1;
		vParms = 23.7534 | 31.248 | 31.248 | 27.3088 | 3.29413 | 3.66155 |
		         3.47959 | 2.82703 | 2.82703 | 2.16579 | 3.77849 | 3.58857 |
				 zeros(15,1) | 
				 -2.7764 | -2.1163 | -1.27597 | -2.82997 | -1.87501 | -0.664099 |
				 6.28881 | 8.27725 | 9.61539 | 10.2819 | -5.20269 | 4.62063 | 7.04669 | 7.4435 | -7.64006 | -5.45963 | 4.6416 | 5.96742 | -9.00621 | -8.08902 | -5.27596 | 3.81987 |
				 zeros(23,1) | 
				 //-0.0537736 | 0.192435 | -0.125405 | 1.48726 | -1.14907 | -0.078094 | 0.165634 | -0.101917 | -0.184503 | 0.157038 | -0.139558 | 0.977172 | -0.0144951 | -0.259133 | 0.0680954 | -0.0206376 |
				 0.939986 | 0.189639 | 0.00963758 | 0 | 0.258271 | -0.0831821 | 1.22141 | 1.02158 |
				 3.6144 | 1.34975 | -3.64171 | -3.21878 | -1.10458 | 1.81415 | -0.932476 | -3.05319 ;
		vParms = 21.8658 | 14.6958 | 8.30028 | 26.1981 | 45.8686 | 7.7136 | 3.3185 | 3.80734 | 1.90728 | 2.54653 | 0.980636 | 3.95701 | -0.48261 | 0.730108 | -0.266359 | -0.171929 | 0.233238 | 1.69053 | 0.0156308 | -0.41635 | 3.40463 | -0.757159 | -0.35997 | 0.0625836 | 0.462428 | 2.34976 | 0.0447396 | -3.02567 | -3.02867 | -1.33457 | -2.92787 | -1.97602 | -1.03749 | 6.1629 | 8.15124 | 9.48935 | 10.1559 | -5.20096 | 4.62245 | 7.04849 | 7.44531 | -7.64856 | -5.46812 | 4.63547 | 5.96129 | -8.88015 | -7.96294 | -5.14992 | 3.92777 | -0.150184 | -0.208931 | 0.039897 | 0.359505 | -0.0976498 | 0.389484 | -0.0500271 | 0.139901 | -0.010094 | 0.190706 | -0.0198573 | 0.399243 | -0.18375 | 0.0812761 | -0.125079 | 0.211662 | -0.0452721 | 0.364175 | -0.265092 | 0.0827635 | 0.239643 | -0.00643855 | 0.0291417 | 0.930611 | 0.085176 | 0.0606721 | 0.195885 | 0.173383 | 0.2424 | 0.0499883 | 0.662109 | 3.196 | 1.39565 | -3.63902 | -2.89775 | -0.765604 | 1.92431 | -0.894936 | -3.15617 ;		 
	}
	else if(s_iModel==17)
	{
		s_iNumMacros = rows(s_mYg);
		s_iNumMacroFactors = 5;
		s_iNumGrades = 4;
		s_iNumTransitionTypes = rows(s_mYc);
		s_iNumFrailtyFactors = 2;
		s_iNumRecRateFactors = 0;
		s_iNumRecRates = 1;
		s_iNumIndustries = 1;
		s_iNumIndustriesLGD = 1;
		vParms = 23.7534 | 31.248 | 31.248 | 27.3088 | 3.29413 | 3.66155 | 3.66155 |
		         3.47959 | 2.82703 | 2.82703 | 2.16579 | 3.77849 | 3.58857 | 3.58857 |
				 zeros(15,1) | 
				 -2.7764 | -2.1163 | -1.27597 | -2.82997 | -1.87501 | -0.664099 |
				 6.28881 | 8.27725 | 9.61539 | 10.2819 | -5.20269 | 4.62063 | 7.04669 | 7.4435 | -7.64006 | -5.45963 | 4.6416 | 5.96742 | -9.00621 | -8.08902 | -5.27596 | 3.81987 |
				 zeros(25,1) | 
				 //-0.0537736 | 0.192435 | -0.125405 | 1.48726 | -1.14907 | -0.078094 | 0.165634 | -0.101917 | -0.184503 | 0.157038 | -0.139558 | 0.977172 | -0.0144951 | -0.259133 | 0.0680954 | -0.0206376 |
				 0.939986 | 0.189639 | 0.00963758 | 0 | 0 | 0.258271 | -0.0831821 | 1.22141 | 1.02158 |
				 3.6144 | 1.34975 | -3.64171 | -3.21878 | -1.10458 | 1.81415 | -0.932476 | -3.05319 ;
		vParms = 22.0916 | 14.7525 | 8.40046 | 27.2775 | 45.5717 | 3.69062 | 4.39197 | 3.33897 | 3.72954 | 1.92221 | 2.54525 | 1.00083 | 3.60518 | 3.81097 | -0.476296 | 0.725842 | -0.266814 | -0.214986 | 0.184915 | 1.60358 | 0.0182419 | -0.456507 | 3.49525 | -0.668704 | -0.373708 | 0.0768117 | 0.484011 | 2.3299 | 0.0303493 | -3.01431 | -3.03368 | -1.33799 | -2.89885 | -1.96623 | -1.03047 | 6.29919 | 8.28763 | 9.62576 | 10.2923 | -5.19625 | 4.63172 | 7.05785 | 7.45467 | -7.64999 | -5.46954 | 4.63473 | 5.96055 | -9.05648 | -8.13929 | -5.32626 | 3.76494 | -0.0983235 | -0.0559471 | 0.0537029 | 0.283203 | -0.0757752 | 1.49736 | -0.699727 | -0.018922 | 0.202136 | -0.011568 | 0.181224 | -0.00388332 | -0.166147 | 0.122887 | -0.134116 | 0.204233 | -0.0275836 | 0.857167 | 0.0864106 | -0.26711 | 0.0434183 | 0.0854423 | 0.052182 | 0.0314604 | 1.57909 | 0.943884 | 0.225667 | 0.0263101 | 0.123852 | 0.150089 | 0.289166 | 0.0507759 | 0.94617 | 0.945397 | 3.59802 | 1.46254 | -3.64793 | -3.30919 | -1.17364 | 1.82866 | -0.940389 | -3.07039 ;		 
	}
	
	
	s_iNumFactors = s_iNumMacroFactors + s_iNumFrailtyFactors + s_iNumRecRateFactors;
	return vParms;
}

getGasMatrices(const vRestrictedParms, const pmA, const pmB, const pmZg, const pvZc, const pmZc,
					const pvSigma, const pdBetaR, const pvZr, const pmZr, const pvBetaP, const pvBetaR,
					const pvTimeDum15, const pvTimeDum308, const pvIp, const pvIr, const iPrint)
{
	decl inc = 0, temp;
	pvBetaP[0] = 0;
	pvBetaR[0] = 0;
	pvIp[0] = 0;
	pvIr[0] = 0;
	pvTimeDum15[0] = 0;
	pvTimeDum308[0] = 0;
	pdBetaR[0] = 0;
	pvZr[0] = 0;
	pmZr[0] = 0 ;
	pvZc[0] = 0;
	pmZc[0] = 0;
	pmZg[0] = 0;
	pvSigma[0] = 0;
		

	if(s_iModel==1)
	{ 
		pmA[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmB[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pvZc[0] = reshape(vRestrictedParms[inc : inc + s_iNumGrades^2 -1], s_iNumGrades, s_iNumGrades);
		inc += s_iNumGrades^2;
		pmZc[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
					1 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
				   0 ~ 1 ;		  
		pvTimeDum15[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pvTimeDum308[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
	}
	else if(s_iModel==2)
	{
		 
		pmA[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmB[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmZg[0] = 1 ~ 0 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 |
				  0 ~ 1 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 |
				  0 ~ 0 ~ 1 ~ 0 ~ 0 ;
		pvSigma[0] = vRestrictedParms[inc:inc + s_iNumMacros - 1] ;
		inc += s_iNumMacros;
		pvZc[0] = reshape(vRestrictedParms[inc : inc + s_iNumGrades^2 -1], s_iNumGrades, s_iNumGrades);
		inc += s_iNumGrades^2;
		pmZc[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
		          vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 1 ;
		pvTimeDum15[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pvTimeDum308[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
	}
	else if(s_iModel==3)
	{
		 
		pmA[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmB[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmZg[0] = 1 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++]  |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++]  |
				  0 ~ 1  |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++]  |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++]  ;
		pvSigma[0] = vRestrictedParms[inc:inc + s_iNumMacros - 1] ;
		inc += s_iNumMacros;
		pvZc[0] = reshape(vRestrictedParms[inc : inc + s_iNumGrades^2 -1], s_iNumGrades, s_iNumGrades);
		inc += s_iNumGrades^2;
		pmZc[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++]  |
		          vRestrictedParms[inc++] ~ vRestrictedParms[inc++]  |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++]  |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++]  ;
		pdBetaR[0] = vRestrictedParms[inc++];
		pvZr[0] = vRestrictedParms[inc++];
		pmZr[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ;
		pvTimeDum15[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pvTimeDum308[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pmZg[0][3][0] = vRestrictedParms[inc]; inc+=1;
	}
	else if(s_iModel==4)
	{
		 
		pmA[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmB[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmZg[0] = 1 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 |
				  0 ~ 1 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ;
		pvSigma[0] = vRestrictedParms[inc:inc + s_iNumMacros - 1] ;
		inc += s_iNumMacros;
		pvZc[0] = reshape(vRestrictedParms[inc : inc + s_iNumGrades^2 -1], s_iNumGrades, s_iNumGrades);
		inc += s_iNumGrades^2;
		pmZc[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
		          vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ;
		pdBetaR[0] = vRestrictedParms[inc++];
		pvZr[0] = vRestrictedParms[inc++];
		pmZr[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ;
		pvTimeDum15[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pvTimeDum308[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pmZg[0][3][0] = vRestrictedParms[inc]; inc+=1;
	}
	else if(s_iModel==5)
	{
		 
		pmA[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmB[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmZg[0] = 1 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 |
				  0 ~ 1 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 ;
		pvSigma[0] = vRestrictedParms[inc:inc + s_iNumMacros - 1] ;
		inc += s_iNumMacros;
		pvZc[0] = reshape(vRestrictedParms[inc : inc + s_iNumGrades^2 -1], s_iNumGrades, s_iNumGrades);
		inc += s_iNumGrades^2;
		pmZc[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
		          vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 1 ;
		pdBetaR[0] = vRestrictedParms[inc++];
		pvZr[0] = vRestrictedParms[inc++];
		pmZr[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++];
		pvTimeDum15[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pvTimeDum308[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pmZg[0][3][0] = vRestrictedParms[inc]; inc+=1;
		pmZc[0][3][3] = vRestrictedParms[inc]; inc+=1;
	}
	else if(s_iModel==6)
	{
		 
		pmA[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmB[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmZg[0] = 1 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
				  0 ~ 1 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
				  0 ~ 0 ~ 1 ;
		pvSigma[0] = vRestrictedParms[inc:inc + s_iNumMacros - 1] ;
		inc += s_iNumMacros;
		pvZc[0] = reshape(vRestrictedParms[inc : inc + s_iNumGrades^2 -1], s_iNumGrades, s_iNumGrades);
		inc += s_iNumGrades^2;
		pmZc[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
		          vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ;
		pdBetaR[0] = vRestrictedParms[inc++];
		pvZr[0] = vRestrictedParms[inc++];
		pmZr[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++];
		pvTimeDum15[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pvTimeDum308[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pmZg[0][3][0] = vRestrictedParms[inc]; inc+=1;
		pmZg[0][5][0] = vRestrictedParms[inc]; inc+=1;
		pmZg[0][5][1] = vRestrictedParms[inc]; inc+=1;
	}
	else if(s_iModel==7)
	{
		 
		pmA[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmB[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmZg[0] = 1 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 |
				  0 ~ 1 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 |
				  0 ~ 0 ~ 1 ~ 0 ;
		pvSigma[0] = vRestrictedParms[inc:inc + s_iNumMacros - 1] ;
		inc += s_iNumMacros;
		pvZc[0] = reshape(vRestrictedParms[inc : inc + s_iNumGrades^2 -1], s_iNumGrades, s_iNumGrades);
		inc += s_iNumGrades^2;
		pmZc[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
		          vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ;
		pdBetaR[0] = vRestrictedParms[inc++];
		pvZr[0] = vRestrictedParms[inc++];
		pmZr[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ;
		pvTimeDum15[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pvTimeDum308[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pmZg[0][3][0] = vRestrictedParms[inc]; inc+=1;
		pmZg[0][5][0] = vRestrictedParms[inc]; inc+=1;
		pmZg[0][5][1] = vRestrictedParms[inc]; inc+=1;
	}
	else if(s_iModel==8)
	{
		 
		pmA[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmB[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmZg[0] = 1 ~ 0 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 |
				  0 ~ 1 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 |
				  0 ~ 0 ~ 1 ~ 0 ~ 0 ;
		pvSigma[0] = vRestrictedParms[inc:inc + s_iNumMacros - 1] ;
		inc += s_iNumMacros;
		pvZc[0] = reshape(vRestrictedParms[inc : inc + s_iNumGrades^2 -1], s_iNumGrades, s_iNumGrades);
		inc += s_iNumGrades^2;
		pmZc[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 |
		          vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ;
		pdBetaR[0] = vRestrictedParms[inc++];
		pvZr[0] = vRestrictedParms[inc++];
		pmZr[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ;
		pvTimeDum15[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pvTimeDum308[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pmZg[0][3][0] = vRestrictedParms[inc]; inc+=1;
		pmZg[0][5][0] = vRestrictedParms[inc]; inc+=1;
		pmZg[0][5][1] = vRestrictedParms[inc]; inc+=1;
	}
	else if(s_iModel==9)
	{
		 
		pmA[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmB[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmZg[0] = 1 ~ 0 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 |
				  0 ~ 1 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 |
				  0 ~ 0 ~ 1 ~ 0 ~ 0 ;
		pvSigma[0] = vRestrictedParms[inc:inc + s_iNumMacros - 1] ;
		inc += s_iNumMacros;
		pvZc[0] = reshape(vRestrictedParms[inc : inc + s_iNumGrades^2 -1], s_iNumGrades, s_iNumGrades);
		inc += s_iNumGrades^2;
		pmZc[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
		          vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 1 ;
		pdBetaR[0] = vRestrictedParms[inc++];
		pvZr[0] = vRestrictedParms[inc++];
		pmZr[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++];
		pvTimeDum15[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pvTimeDum308[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pmZg[0][3][0] = vRestrictedParms[inc]; inc+=1;
		pmZg[0][5][0] = vRestrictedParms[inc]; inc+=1;
		pmZg[0][5][1] = vRestrictedParms[inc]; inc+=1;
		pmZc[0][3][3] = vRestrictedParms[inc]; inc+=1;
	}
	else if(s_iModel==10)
	{
		 
		pmA[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmB[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmZg[0] = 1 ~ 0 ~ 0 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 ~ 0 |
				  0 ~ 1 ~ 0 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 ~ 0 |
				  0 ~ 0 ~ 1 ~ 0 ~ 0 ~ 0 ;
		pvSigma[0] = vRestrictedParms[inc:inc + s_iNumMacros - 1] ;
		inc += s_iNumMacros;
		pvZc[0] = reshape(vRestrictedParms[inc : inc + s_iNumGrades^2 -1], s_iNumGrades, s_iNumGrades);
		inc += s_iNumGrades^2;
		pmZc[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 |
		          vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 1 ~ 0 ;
		pdBetaR[0] = vRestrictedParms[inc++];
		pvZr[0] = vRestrictedParms[inc++];
		pmZr[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ;
		pvTimeDum15[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pvTimeDum308[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pmZg[0][3][0] = vRestrictedParms[inc]; inc+=1;
		pmZg[0][5][0] = vRestrictedParms[inc]; inc+=1;
		pmZg[0][5][1] = vRestrictedParms[inc]; inc+=1;
		pmZc[0][3][3] = vRestrictedParms[inc]; inc+=1;
	}
	else if(s_iModel==11)
	{
		 
		pmA[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmB[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmZg[0] = 1 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ 1 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ;
		pvSigma[0] = vRestrictedParms[inc:inc + s_iNumMacros - 1] ;
		inc += s_iNumMacros;
		pvZc[0] = reshape(vRestrictedParms[inc : inc + s_iNumGrades^2 -1], s_iNumGrades, s_iNumGrades);
		inc += s_iNumGrades^2;
		pmZc[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++]  |
		          vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++]  |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++]  ;
		pdBetaR[0] = vRestrictedParms[inc++];
		pvZr[0] = vRestrictedParms[inc++];
		pmZr[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ;
		pvTimeDum15[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pvTimeDum308[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;

	}
	else if(s_iModel==12)
	{
		pmA[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmB[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmZg[0] = 1 ~ 0 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ 1 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 ;
		pvSigma[0] = vRestrictedParms[inc:inc + s_iNumMacros - 1] ;
		inc += s_iNumMacros;
		pvZc[0] = reshape(vRestrictedParms[inc : inc + s_iNumGrades^2 -1], s_iNumGrades, s_iNumGrades);
		inc += s_iNumGrades^2;
		pmZc[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++]  ~ vRestrictedParms[inc++] |
		          vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++]  ~ vRestrictedParms[inc++] |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++]  ~ vRestrictedParms[inc++] |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++]  ~ 1 ;
		pdBetaR[0] = vRestrictedParms[inc++];
		pvZr[0] = vRestrictedParms[inc++];
		pmZr[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ;
		pvTimeDum15[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pvTimeDum308[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		//pmZg[0][3][0] = vRestrictedParms[inc]; inc+=1;
		//pmZg[0][5][0] = vRestrictedParms[inc]; inc+=1;
	    //pmZg[0][5][1] = vRestrictedParms[inc]; inc+=1;
		//pmZc[0][3][3] = vRestrictedParms[inc]; inc+=1; 
		
	}
	else if(s_iModel==13)
	{
		 
		pmA[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmB[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmZg[0] = 1 ~ 0 ~ 0 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ 1 ~ 0 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 ~ 0 ;
		pvSigma[0] = vRestrictedParms[inc:inc + s_iNumMacros - 1] ;
		inc += s_iNumMacros;
		pvZc[0] = reshape(vRestrictedParms[inc : inc + s_iNumGrades^2 -1], s_iNumGrades, s_iNumGrades);
		inc += s_iNumGrades^2;
		pmZc[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
		          vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ;
		pdBetaR[0] = vRestrictedParms[inc++];
		pvZr[0] = vRestrictedParms[inc++];
		pmZr[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++];
		pvTimeDum15[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pvTimeDum308[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
	}
	else if(s_iModel==14)
	{
		 
		pmA[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmB[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmZg[0] = 1 ~ 0 ~ 0 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ 1 ~ 0 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ vRestrictedParms[inc++] ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ 0 ~ 1 ~ 0 ~ 0 ~ 0 |
				  0 ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 ~ 0 ;
		pvSigma[0] = vRestrictedParms[inc:inc + s_iNumMacros - 1] ;
		inc += s_iNumMacros;
		pvZc[0] = reshape(vRestrictedParms[inc : inc + s_iNumGrades^2 -1], s_iNumGrades, s_iNumGrades);
		inc += s_iNumGrades^2;
		pmZc[0] = vRestrictedParms[inc++] ~ 0 ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
		          0 ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 |
				  vRestrictedParms[inc++] ~ 0 ~ vRestrictedParms[inc++] ~ 0 ~ vRestrictedParms[inc++] ~ 1 ;
		pdBetaR[0] = vRestrictedParms[inc++];
		pvZr[0] = vRestrictedParms[inc++];
		pmZr[0] = 0 ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++];
		pvTimeDum15[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pvTimeDum308[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
	}
	else if(s_iModel==15)
	{
		 
		pmA[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmB[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmZg[0] = 1 ~ 0 ~ 0 ~ 0 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ 1 ~ 0 ~ 0 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 ~ 0 ~ 0 ;
		pvSigma[0] = vRestrictedParms[inc:inc + s_iNumMacros - 1] ;
		inc += s_iNumMacros;
		pvZc[0] = reshape(vRestrictedParms[inc : inc + s_iNumGrades^2 -1], s_iNumGrades, s_iNumGrades);
		inc += s_iNumGrades^2;
		pmZc[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 |
		          vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 ;
		pdBetaR[0] = vRestrictedParms[inc++];
		pvZr[0] = vRestrictedParms[inc++];
		pmZr[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1;
		pvTimeDum15[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pvTimeDum308[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
	}
	else if(s_iModel==16)
	{	 
		pmA[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmB[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmZg[0] = 1 ~ 0 ~ 0 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ 1 ~ 0 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 ;
		pvSigma[0] = vRestrictedParms[inc:inc + s_iNumMacros - 1] ;
		inc += s_iNumMacros;
		pvZc[0] = reshape(vRestrictedParms[inc : inc + s_iNumGrades^2 -1], s_iNumGrades, s_iNumGrades);
		inc += s_iNumGrades^2;
		pmZc[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
		          vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ;
		pdBetaR[0] = vRestrictedParms[inc++];
		pvZr[0] = vRestrictedParms[inc++];
		pmZr[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ;
		pvTimeDum15[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pvTimeDum308[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
	}
	else if(s_iModel==17)
	{	 
		pmA[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmB[0] = diag(vRestrictedParms[inc:inc + s_iNumFactors - 1]);
		inc += s_iNumFactors;
		pmZg[0] = 1 ~ 0 ~ 0 ~ 0 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ 1 ~ 0 ~ 0 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 0 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 ~ 0 ;
		pvSigma[0] = vRestrictedParms[inc:inc + s_iNumMacros - 1] ;
		inc += s_iNumMacros;
		pvZc[0] = reshape(vRestrictedParms[inc : inc + s_iNumGrades^2 -1], s_iNumGrades, s_iNumGrades);
		inc += s_iNumGrades^2;
		pmZc[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
		          vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ~ 0 |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] |
				  vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ 1 ;
		pdBetaR[0] = vRestrictedParms[inc++];
		pvZr[0] = vRestrictedParms[inc++];
		pmZr[0] = vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++] ~ vRestrictedParms[inc++];
		pvTimeDum15[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
		pvTimeDum308[0] = vRestrictedParms[inc:inc+s_iNumGrades-1] ;
		inc += s_iNumGrades;
	}
	
	if(iPrint == 1)
	{
		println("mA = ",pmA[0]);
		println("mB = ",pmB[0]);
		//println("B_lag = ",pmB_lag[0]);
		println("mZg = ",pmZg[0]);
		println("mSigma = ",diag(pvSigma[0]));
		println("vZc = ",pvZc[0]);
		//println("vIp = ",pvIp[0]);
		//println("vIr = ",pvIr[0]);
		println("mZc = ",pmZc[0]);
		println("dBetaR = ",pdBetaR[0]);
		println("vZr = ",pvZr[0]);
		println("mZr = ",pmZr[0]);
		println("vTimeDum15 = ",pvTimeDum15[0]);
		println("vTimeDum308 = ",pvTimeDum308[0]);
	}
}

logLikelihoodDiagnostics(const vParms, const pdLoglike, const pvG, const pmHess)
{

	decl vNp, vYg, vYp, mSy, vSy, mX, mXg, mAB, mMeans, mProbs, mP, mA, mB, mB_lag, mS, mScores, mLogOdds, mInfo, mInvInfo, mFactors, mYg, mYc, mNp, mYr;
	decl vFactorsLag, vYr, vIp, vIr, vProbs, vRR, vAB, vBB, vZg, mZg, vZc, mZc, vZr, mZr, vSigma2, mSigma, vMu, vEps;
	decl vDiffProbs, vBetaP, vBetaR, vIndex, vFactors, dMu, dAlpha, dBeta, dBetaR, dSigma2R, dLoglike, vScore, vSt, vRestrictedParms;
	decl iWarning, iNumObs, iNumTransPerGrade, iNumIndustriesLGD, iNumIndustries, iNumGrades, iNumFactors, iNumTransitionTypes, iNumMacros, iNumFrailtyFactors, iNumRecRates, iNumRecRateFactors, mIndex;
	decl temp, temp2, temp3, temp4, count1, count2;
	decl vTimeDum15, vTimeDum308;
	decl mPred, mScaledResids, mPredicted, mProbIntegralsMacrosAlt, mProbIntegralsMacros, mProbIntegralsLGDs, mScaledScores, mEigval, mEigvec, mUU;
	decl t, i, j, k, sign, dA, dB;
	decl vSelect = range(0,15,1);
	decl vInd = 0 | 0 | 0 | 0 | 1 | 0 | 0 | 0 | 1 | 1 | 0 | 0 | 1 | 1 | 1 | 0;
	pdLoglike[0] = -.Inf;					
			
	iNumObs = s_iNumObs;
	iNumFactors = s_iNumFactors;
	iNumTransitionTypes = s_iNumTransitionTypes;
	iNumMacros = s_iNumMacros;
	iNumFrailtyFactors = s_iNumFrailtyFactors;
	iNumRecRateFactors = s_iNumRecRateFactors;
	iNumRecRates = s_iNumRecRates;
	iNumGrades = s_iNumGrades;
	iNumTransPerGrade = iNumGrades + 1;
	iNumIndustries = s_iNumIndustries;
	iNumIndustriesLGD = s_iNumIndustriesLGD;
	mYg = s_mYg;
	mYc = s_mYc;
	mYr = s_mYr;
	mNp = s_mRp;
	mXg = s_mYg;

	//vRestrictedParms = restrictParms(vParms .* s_vParmsOrig);
	if(s_iRestrict==1)
	{
		vRestrictedParms = restrictParms(vParms);
	}
	else
	{
		vRestrictedParms = vParms;
	}
	getGasMatrices(vRestrictedParms, &mA, &mB, &mZg, &vZc, &mZc, &vSigma2, &dBetaR, &vZr, &mZr,
	                          &vBetaP, &vBetaR, &vTimeDum15, &vTimeDum308, &vIp, &vIr, s_iPrint);
	s_mZg = mZg;
	mSigma = diag(vSigma2);
			
	mFactors = zeros(iNumFactors, iNumObs);
	mScores = zeros(iNumFactors, iNumObs);
	mScaledScores = zeros(iNumFactors, iNumObs);
	mLogOdds = zeros(iNumTransitionTypes, iNumObs);
	mProbIntegralsMacros = zeros(iNumMacros,iNumObs);
	mProbIntegralsMacrosAlt = zeros(1,iNumObs);
	mProbIntegralsLGDs = ones(22,iNumObs)*.NaN;
	mScaledResids = zeros(iNumMacros,iNumObs)*.NaN;
	mPred = zeros(iNumMacros,iNumObs)*.NaN;
	mProbs = zeros(iNumGrades*(iNumGrades+1), iNumObs);
	mMeans = zeros(iNumIndustriesLGD,iNumObs);
	mPredicted = ones(6,iNumObs)*.NaN;
	
	if(iNumIndustriesLGD==1)
	{
		mAB = zeros(2,iNumObs);
	}
	else
	{
		mAB = new array[iNumIndustriesLGD];
		mAB[0] = zeros(2,iNumObs);
		mAB[1] = zeros(2,iNumObs);
		mAB[2] = zeros(2,iNumObs);
		mAB[3] = zeros(2,iNumObs);
		mAB[4] = zeros(2,iNumObs);
		mAB[5] = zeros(2,iNumObs);
		mAB[6] = zeros(2,iNumObs);
	}
	vFactors = vFactorsLag = zeros(iNumFactors,1);
	//vEtaLag = 0;
	dLoglike = 0;
	vBB = 1 ~ -1;
	if(iNumMacros>0)
	{
		iWarning = oxwarning(0);
		oxwarning(iWarning);
	}
	else
	{
		mYg = ones(1,iNumObs)*.NaN;
	}
	dLoglike = 0;
	mS = unit(iNumFactors);
	mIndex = zeros(iNumFactors,iNumFactors);

	// then the rest of the observations

	decl mPiTilde, mPi, mPiScore, tempPi, vEmpProb, mPiT;
	for(t=0;t<iNumObs;t++)			
	{

		// initialize score and info matrix
		vScore = zeros(iNumFactors,1);
		mInfo = zeros(iNumFactors,iNumFactors);
		mFactors[][t] = vFactors;							
		
		if(iNumMacros>0)
		{
			vMu = mZg * vFactors;
			vEps = mYg[][t] - vMu;

			
			mScaledResids[][t] = vEps./sqrt(vSigma2);
			mPred[][t] = vMu;
			// update: Gaussian part of the likelihood

			dLoglike += sumc( isdotnan(mYg[][t]) .? 0 .: (-0.5*log(M_2PI) -0.5*log(vSigma2) - 0.5 .* sqr(vEps) ./ vSigma2) );

			for(j=0;j<iNumMacros;j++)
			{
				// This is the Diebold, Gunther, Tay (1998) step
				mProbIntegralsMacros[j][t] = isdotnan(mYg[j][t]) .? .NaN .: probmvn(mYg[j][t] - vMu[j],vSigma2[j]);
			}
			vScore += mZg' * ( isdotnan(mYg[][t]) .? 0 .: (vEps ./vSigma2));
			mInfo += mZg' * ( diag(isdotnan(mYg[][t]) .? 0 .: (1 ./vSigma2) )) * mZg;
  
		}
					 
		if(iNumTransitionTypes>0)
		{
				
			mPiTilde = 0 ~
			(
				1.0 ./
				(
					1 +
					exp(-(
						vZc - mZc * vFactors
						- ((t==15) ? vTimeDum15 : 0)
						- ((t==308) ? vTimeDum308 : 0)
					))
				)
			) ~ 1;

			
			mPi = mPiTilde[][1:] - mPiTilde[][:iNumGrades];
			//println(rows(mPi)~columns(mPi));
			mProbs[][t] = vec(mPi);
			//println(mPi);
			mPi = (mPi .< 1e-6) .? 1e-6 .: mPi;
			mPiScore = mPiTilde[][1:] .* (1 - mPiTilde[][1:]) - mPiTilde[][:iNumGrades] .* (1 - mPiTilde[][:iNumGrades]);

				//temp = sumr(reshape(mYc[][t],iNumGrades,iNumGrades+1))';
				temp = (s_mRetExp[][t] - s_mWith[][t])'; 
				tempPi = setlower(mPi,0);
				tempPi = setdiagonal(tempPi,0);
				mPiT = ones(iNumGrades,iNumGrades+1) - mPi;
			
				mPredicted[0][t] = sumr(temp*tempPi);  // expected number of downgrades

				tempPi = setlower(mPiT.*mPi,0);
				tempPi = setdiagonal(tempPi,0);

				mPredicted[2][t] = sumr(temp*tempPi);

				tempPi = setupper(mPi,0);
				tempPi = setdiagonal(tempPi,0);
			
				mPredicted[1][t] = sumr(temp*tempPi);	 // expected number of upgrades

				tempPi = setupper(mPi.*mPiT,0);
				tempPi = setdiagonal(tempPi,0);
				mPredicted[3][t] = sumr(temp*tempPi);

				mPredicted[4][t] = temp*mPi[][iNumGrades];
				mPredicted[5][t] = sumc(reshape(mYc[][t],iNumGrades,iNumGrades+1)[][iNumGrades]);
			
			//println(mPredicted[4][t]~sumc(reshape(mYc[][t],iNumGrades,iNumGrades+1)[][iNumGrades]));
			//println(t~sumc(mYc[][t]));
				
			// compute log-likelihood increment
			dLoglike += sumc(mYc[][t] .* log(vecr(mPi)));
		
			// compute density score
			vScore += -sumc( (mYc[][t] ./ vecr(mPi) .* vecr(mPiScore)) .* (mZc ** ones(iNumGrades+1,1)) )';

			// compute density information matrix
			mInfo += ((mZc' ** ones(1,iNumGrades+1)) ) *
				(
					(sqr(vecr(mPiScore)) ./ vecr(mPi))
					.*
					(
						(mZc .* sumr(reshape(mYc[][t],iNumGrades,iNumGrades+1)))
						** ones(iNumGrades+1,1)
					)
				);

		}

		 if(iNumRecRates>0)
		 {
		 		dMu = exp(vZr + mZr*vFactors)/(1 + exp(vZr + mZr*vFactors));
				//dSigma2R = dMu*(1 - dMu)/(1 + dBetaR);
				dAlpha = dBetaR*dMu; 
				dBeta = dBetaR*(1 - dMu);
				mMeans[][t] = dMu;
				mAB[0][t] = dAlpha;
				mAB[1][t] = dBeta;

				vYr = deleter(selectifc(mYr[3][],mYr[0][] .== t)');
			
				if(rows(vYr)>0)
				{
		 			dLoglike += sumc( loggamma(dAlpha + dBeta) - loggamma(dAlpha) - loggamma(dBeta) +
									(dAlpha - 1)*log(vYr) + (dBeta - 1)*log(1 - vYr) );
					vAB = sumc(
							polygamma(dAlpha + dBeta,0) +
							(
								log(vYr) - polygamma(dAlpha,0)
								~
			         			log(1 - vYr) - polygamma(dBeta,0)
							)
						)';	  
					vScore += dBetaR*dMu*(1-dMu)*mZr'*vBB*vAB;
					temp = diag(polygamma(dAlpha,1) | polygamma(dBeta,1)) - polygamma(dAlpha + dBeta,1);
					mInfo += sqr(dBetaR*dMu*(1-dMu))*mZr'(rows(vYr)*(vBB*temp*vBB'))*mZr;

					for(j=0;j<rows(vYr);j++)
					{
						// This is the Diebold, Gunther, Tay (1998) step  // Added by Drew;
						mProbIntegralsLGDs[j][t] = probbeta(vYr[j], dAlpha, dBeta);
					}
				}
			
		 }
			 
		// check likelihood existence
		if(isnan(dLoglike))
		{
			println("hello");
			break;
		}

		// update with GAS step
		if(s_iInfoSmooth==0)
		{
			if(isnan(mInfo) || (sumc(vecr(isdotinf(mInfo))) != 0))
			{
				mInvInfo = unit(s_iNumFactors);
			}
			else
			{
				eigensym(mInfo,&mEigval,&mEigvec);
			
				vIndex = <>;
				for(j=0;j<iNumFactors;j++)
				{
					if(mEigval[j]>0)
					{
						vIndex |= j;
					}
				}
				if(vIndex==<>)
				{
					mInvInfo = zeros(s_iNumFactors);
				}
				else
				{
					mUU = mEigvec[][vIndex];
					mInvInfo = mUU*(diag(1 ./mEigval[vIndex]))*mUU';
				}
			}
		}
		else if(s_iInfoSmooth==1)
		{
			
			if(isnan(mInfo) || (sumc(vecr(isdotinf(mInfo))) != 0))
			{
				mInvInfo = .NaN;
			}
			else
			{
				eigensym(mInfo,&mEigval,&mEigvec);
			
				vIndex = sumr(mEigval .> 0.5e-5);
				if(vIndex == 0)
				{
					mInvInfo = zeros(s_iNumFactors,s_iNumFactors);
				}
				else
				{
					mInvInfo = (mEigvec[][:vIndex - 1] ./ sqrt(mEigval[:vIndex - 1])) * mEigvec[][:vIndex - 1]';
					//oxwarning(iWarning);
				}
			}
		}
		
		vSt = mInvInfo * vScore;
		mScores[][t] = vScore;
		mScaledScores[][t] = vSt;
		
		vFactors = mB*vFactors + mA * vSt;
		vFactorsLag = mFactors[][t];
	}
	// These are the bad time periods with re-ratings where our predictions are way off
	mPredicted[][15] = ones(6,1)*.NaN;
	mPredicted[][251] = ones(6,1)*.NaN;
	mPredicted[][308] = ones(6,1)*.NaN;
	
	s_mScores = mScores;
	s_mScaledResids = mScaledResids;
	s_mScaledScores = mScaledScores;
	s_vFactors = vFactors;
	s_mMeans = mMeans;
	s_mProbs = mProbs;
	s_mPred = mPred;
	s_mAB = mAB;
	s_mFactors = mFactors;
	s_mLogOdds = mLogOdds;
	s_mProbIntegralsMacrosAlt = mProbIntegralsMacrosAlt;
	s_mProbIntegralsMacros = mProbIntegralsMacros;
	s_mProbIntegralsLGDs = mProbIntegralsLGDs;
	s_mPredicted = mPredicted;

	if(iNumIndustries==1)
	{
//		s_mProbs[0][15] = s_mProbs[0][14];
//		s_mProbs[4][15] = s_mProbs[4][14];
//		s_mProbs[5][15] = s_mProbs[5][14];
//		s_mProbs[5][308] = s_mProbs[5][307];
//		s_mProbs[9][308] = s_mProbs[9][307];
//		s_mProbs[10][308] = s_mProbs[10][307];
//		s_mProbs[14][308] = s_mProbs[14][307];
		s_mProbs[][15] = s_mProbs[][14];
		s_mProbs[][308] = s_mProbs[][307];
	}
	else if(iNumIndustries==7)
	{
		i = 0;
		for(j=0;j<iNumIndustries;j++)
		{
			s_mProbs[0+i][15] = s_mProbs[0+i][14];
			s_mProbs[4+i][15] = s_mProbs[4+i][14];
			s_mProbs[5+i][15] = s_mProbs[5+i][14];
			s_mProbs[5+i][308] = s_mProbs[5+i][307];
			s_mProbs[9+i][308] = s_mProbs[9+i][307];
			s_mProbs[10+i][308] = s_mProbs[10+i][307];
			s_mProbs[14+i][308] = s_mProbs[14+i][307];
			i = i + 16;
		}
	}
	
	pdLoglike[0] = double(dLoglike);
	if(s_iPlot== 1)
	{
			//Draw(0,s_mFactors);
			DrawTitle(0,sprint("Lik = ",pdLoglike[0][0][0])); //Draw(0,s_mTrueFactors);
			for(decl j=0; j<iNumFactors; j++)
			{
				DrawXMatrix(j, s_mFactors[j][], {""}, s_vTime, {""}, 0, 2);
			}
	  		ShowDrawWindow();
	}
	if(isnan(pdLoglike[0]))
	{
		return 0;
	}
	else
	{
		return 1;
	}
}

logLikelihood(const vParms, const pdLoglike, const pvG, const pmHess)
{

	decl vNp, vYg, vYp, mSy, vSy, mX, mXg, mAB, mMeans, mProbs, mP, mA, mB, mB_lag, mS, mScores, mLogOdds, mInfo, mInvInfo, mFactors, mYg, mYc, mNp, mYr;
	decl vFactorsLag, vYr, vIp, vIr, vProbs, vRR, vAB, vBB, vZg, mZg, vZc, mZc, vZr, mZr, vSigma2, mSigma, vMu, vEps;
	decl vDiffProbs, vBetaP, vBetaR, vIndex, vFactors, dMu, dAlpha, dBeta, dBetaR, dSigma2R, dLoglike, vScore, vSt, vRestrictedParms;
	decl iWarning, iNumObs, iNumTransPerGrade, iNumIndustriesLGD, iNumIndustries, iNumGrades, iNumFactors, iNumTransitionTypes, iNumMacros, iNumFrailtyFactors, iNumRecRates, iNumRecRateFactors, mIndex;
	decl temp, temp2, temp3, temp4, count1, count2;
	decl vTimeDum15, vTimeDum308;
	decl mScaledScores, mEigval, mEigvec, mUU;
	decl t, i, j, k, sign, dA, dB;
	decl vSelect = range(0,15,1);
	decl vInd = 0 | 0 | 0 | 0 | 1 | 0 | 0 | 0 | 1 | 1 | 0 | 0 | 1 | 1 | 1 | 0;
	pdLoglike[0] = -.Inf;					
			
	iNumObs = s_iNumObs;
	iNumFactors = s_iNumFactors;
	iNumTransitionTypes = s_iNumTransitionTypes;
	iNumMacros = s_iNumMacros;
	iNumFrailtyFactors = s_iNumFrailtyFactors;
	iNumRecRateFactors = s_iNumRecRateFactors;
	iNumRecRates = s_iNumRecRates;
	iNumGrades = s_iNumGrades;
	iNumTransPerGrade = iNumGrades + 1;
	iNumIndustries = s_iNumIndustries;
	iNumIndustriesLGD = s_iNumIndustriesLGD;
	mYg = s_mYg;
	mYc = s_mYc;
	mYr = s_mYr;
	mNp = s_mRp;
	mXg = s_mYg;

	//vRestrictedParms = restrictParms(vParms .* s_vParmsOrig);
	if(s_iRestrict==1)
	{
		vRestrictedParms = restrictParms(vParms);
	}
	else
	{
		vRestrictedParms = vParms;
	}
	getGasMatrices(vRestrictedParms, &mA, &mB, &mZg, &vZc, &mZc, &vSigma2, &dBetaR, &vZr, &mZr,
	                          &vBetaP, &vBetaR, &vTimeDum15, &vTimeDum308, &vIp, &vIr, s_iPrint);
	s_mZg = mZg;
	mSigma = diag(vSigma2);
			
	mFactors = zeros(iNumFactors, iNumObs);
	mScores = zeros(iNumFactors, iNumObs);
	mScaledScores = zeros(iNumFactors, iNumObs);
	mLogOdds = zeros(iNumTransitionTypes, iNumObs);
	mProbs = zeros(iNumGrades*(iNumGrades)*iNumIndustries, iNumObs);
	mMeans = zeros(iNumIndustriesLGD,iNumObs);
	if(iNumIndustriesLGD==1)
	{
		mAB = zeros(2,iNumObs);
	}
	else
	{
		mAB = new array[iNumIndustriesLGD];
		mAB[0] = zeros(2,iNumObs);
		mAB[1] = zeros(2,iNumObs);
		mAB[2] = zeros(2,iNumObs);
		mAB[3] = zeros(2,iNumObs);
		mAB[4] = zeros(2,iNumObs);
		mAB[5] = zeros(2,iNumObs);
		mAB[6] = zeros(2,iNumObs);
	}
	vFactors = vFactorsLag = zeros(iNumFactors,1);
	//vEtaLag = 0;
	dLoglike = 0;
	vBB = 1 ~ -1;
	if(iNumMacros>0)
	{
		iWarning = oxwarning(0);
		oxwarning(iWarning);
	}
	else
	{
		mYg = ones(1,iNumObs)*.NaN;
	}
	dLoglike = 0;
	mS = unit(iNumFactors);
	mIndex = zeros(iNumFactors,iNumFactors);

	// then the rest of the observations

	decl mPiTilde, mPi, mPiScore;
	for(t=0;t<iNumObs;t++)
	{

		// initialize score and info matrix
		vScore = zeros(iNumFactors,1);
		mInfo = zeros(iNumFactors,iNumFactors);
		mFactors[][t] = vFactors;							
		
		if(iNumMacros>0)
		{
			vMu = mZg * vFactors;
			vEps = mYg[][t] - vMu;
 
			// update: Gaussian part of the likelihood

			dLoglike += sumc( isdotnan(mYg[][t]) .? 0 .: (-0.5*log(M_2PI) -0.5*log(vSigma2) - 0.5 .* sqr(vEps) ./ vSigma2) );

			vScore += mZg' * ( isdotnan(mYg[][t]) .? 0 .: (vEps ./vSigma2));
			mInfo += mZg' * ( diag(isdotnan(mYg[][t]) .? 0 .: (1 ./vSigma2) )) * mZg;

//			println(dLoglike);
//			println(vScore);
//			println(mInfo);
//			println(invert(mInfo)*vScore);
//			return;
		}
					 
		if(iNumTransitionTypes>0)
		{
				
			mPiTilde = 0 ~
			(
				1.0 ./
				(
					1 +
					exp(-(
						vZc - mZc * vFactors
						- ((t==15) ? vTimeDum15 : 0)
						- ((t==308) ? vTimeDum308 : 0)
					))
				)
			) ~ 1;
			
			mPi = mPiTilde[][1:] - mPiTilde[][:iNumGrades];
			mPi = (mPi .< 1e-6) .? 1e-6 .: mPi;
			//mProbs[][t] = mPi;
			  
			mPiScore = mPiTilde[][1:] .* (1 - mPiTilde[][1:]) - mPiTilde[][:iNumGrades] .* (1 - mPiTilde[][:iNumGrades]);
				
			// compute log-likelihood increment
			dLoglike += sumc(mYc[][t] .* log(vecr(mPi)));
		
			// compute density score
			vScore += -sumc( (mYc[][t] ./ vecr(mPi) .* vecr(mPiScore)) .* (mZc ** ones(iNumGrades+1,1)) )';

			// compute density information matrix
			mInfo += ((mZc' ** ones(1,iNumGrades+1)) ) *
				(
					(sqr(vecr(mPiScore)) ./ vecr(mPi))
					.*
					(
						(mZc .* sumr(reshape(mYc[][t],iNumGrades,iNumGrades+1)))
						** ones(iNumGrades+1,1)
					)
				);

		}

		 if(iNumRecRates>0)
		 {
		 		dMu = exp(vZr + mZr*vFactors)/(1 + exp(vZr + mZr*vFactors));
				
				//dSigma2R = dMu*(1 - dMu)/(1 + dBetaR);
				dAlpha = dBetaR*dMu; 
				dBeta = dBetaR*(1 - dMu);
				mMeans[][t] = dMu;
				mAB[0][t] = dAlpha;
				mAB[1][t] = dBeta;

				//println(t~dMu~dAlpha~dBeta);
				
				vYr = deleter(selectifc(mYr[3][],mYr[0][] .== t)');

				//println(vYr);
				if(rows(vYr)>0)
				{
		 			dLoglike += sumc( loggamma(dAlpha + dBeta) - loggamma(dAlpha) - loggamma(dBeta) +
									(dAlpha - 1)*log(vYr) + (dBeta - 1)*log(1 - vYr) );
					vAB = sumc(
							polygamma(dAlpha + dBeta,0) +
							(
								log(vYr) - polygamma(dAlpha,0)
								~
			         			log(1 - vYr) - polygamma(dBeta,0)
							)
						)';	  
					vScore += dBetaR*dMu*(1-dMu)*mZr'*vBB*vAB;
					temp = diag(polygamma(dAlpha,1) | polygamma(dBeta,1)) - polygamma(dAlpha + dBeta,1);
					mInfo += sqr(dBetaR*dMu*(1-dMu))*mZr'(rows(vYr)*(vBB*temp*vBB'))*mZr;
				}
			
		 }
			 
		// check likelihood existence
		if(isnan(dLoglike))
		{
			println("hello");
			break;
		}

		// update with GAS step
		if(s_iInfoSmooth==0)
		{
			if(isnan(mInfo) || (sumc(vecr(isdotinf(mInfo))) != 0))
			{
				mInvInfo = unit(s_iNumFactors);
			}
			else
			{
				eigensym(mInfo,&mEigval,&mEigvec);
			
				vIndex = <>;
				for(j=0;j<iNumFactors;j++)
				{
					if(mEigval[j]>0)
					{
						vIndex |= j;
					}
				}
				if(vIndex==<>)
				{
					mInvInfo = zeros(s_iNumFactors);
				}
				else
				{
					mUU = mEigvec[][vIndex];
					mInvInfo = mUU*(diag(1 ./mEigval[vIndex]))*mUU';
				}
			}
		}
		else if(s_iInfoSmooth==1)
		{
			
			if(isnan(mInfo) || (sumc(vecr(isdotinf(mInfo))) != 0))
			{
				mInvInfo = .NaN;
			}
			else
			{
				eigensym(mInfo,&mEigval,&mEigvec);
			
				vIndex = sumr(mEigval .> 0.5e-5);
				if(vIndex == 0)
				{
					mInvInfo = zeros(s_iNumFactors,s_iNumFactors);
				}
				else
				{
					mInvInfo = (mEigvec[][:vIndex - 1] ./ sqrt(mEigval[:vIndex - 1])) * mEigvec[][:vIndex - 1]';
					//oxwarning(iWarning);
				}
			}
		}
		
		vSt = mInvInfo * vScore;
		mScores[][t] = vScore;
		mScaledScores[][t] = vSt;
		
		vFactors = mB*vFactors + mA * vSt;
		vFactorsLag = mFactors[][t];
	}
					  
	s_mScores = mScores;
	s_mScaledScores = mScaledScores;
	s_vFactors = vFactors;
	s_mMeans = mMeans;
	s_mProbs = mProbs;
	s_mAB = mAB;
	s_mFactors = mFactors;
	s_mLogOdds = mLogOdds;

	if(iNumIndustries==1)
	{
		s_mProbs[0][15] = s_mProbs[0][14];
		s_mProbs[4][15] = s_mProbs[4][14];
		s_mProbs[5][15] = s_mProbs[5][14];
		s_mProbs[5][308] = s_mProbs[5][307];
		s_mProbs[9][308] = s_mProbs[9][307];
		s_mProbs[10][308] = s_mProbs[10][307];
		s_mProbs[14][308] = s_mProbs[14][307];
	}
	else if(iNumIndustries==7)
	{
		i = 0;
		for(j=0;j<iNumIndustries;j++)
		{
			s_mProbs[0+i][15] = s_mProbs[0+i][14];
			s_mProbs[4+i][15] = s_mProbs[4+i][14];
			s_mProbs[5+i][15] = s_mProbs[5+i][14];
			s_mProbs[5+i][308] = s_mProbs[5+i][307];
			s_mProbs[9+i][308] = s_mProbs[9+i][307];
			s_mProbs[10+i][308] = s_mProbs[10+i][307];
			s_mProbs[14+i][308] = s_mProbs[14+i][307];
			i = i + 16;
		}
	}
	
	pdLoglike[0] = double(dLoglike);
	if(s_iPlot== 1)
	{
			//Draw(0,s_mFactors);
			DrawTitle(0,sprint("Lik = ",pdLoglike[0][0][0])); //Draw(0,s_mTrueFactors);
			for(decl j=0; j<iNumFactors; j++)
			{
				DrawXMatrix(j, s_mFactors[j][], {""}, s_vTime, {""}, 0, 2);
			}
	  		ShowDrawWindow();
	}
	if(isnan(pdLoglike[0]))
	{
		return 0;
	}
	else
	{
		return 1;
	}
}

computeGradient(const func, const vParms, const deltagrad)
{
	decl m, k, mI, mGradient, fbase, vParms2, vParmsTemp;
  	m = rows(vParms);
	k = columns(vParms);
	vParmsTemp = vParms;
	if(m==1)
	{
		vParmsTemp = vParms'; 
	}
	m = rows(vParmsTemp);
	mI = unit(m);
	fbase = func(vParmsTemp);
	mGradient = zeros(m,m);
	for(decl i=0;i<m;i++)
	{
		vParms2 = vParmsTemp + deltagrad*mI[][i];
		mGradient[][i] = (func(vParms2)-fbase)/deltagrad ;
	}
	return mGradient;
}

standardErrors(const objFunction, const restrictionFunction, const vParms, const pvParms, const pvStdErrors)
{
	decl mHess, mJacobian, ir;

	// ============================================ //
	//	compute standard errors
	// ============================================ //
	ir = Num2Derivative(objFunction, vParms, &mHess);
    if (!ir)
    {	print("Covar() failed in numerical second derivatives\n");
		pvParms[0] = zeros(vParms);
		pvStdErrors[0] = zeros(vParms); 
        return;
    }
    mJacobian = computeGradient(restrictionFunction,vParms, 0.001);
	pvParms[0] = restrictionFunction(vParms);
	pvStdErrors[0] = sqrt(diagonal(mJacobian*(invert(-mHess))*mJacobian'))';
}

getData(const pmYg, const pvTime, const pmRp, const pmWith, const pmExp, const pmEnter, const pmRetExp,
        const pmYc, const pmYr, const pmLr, const pmLi, const INDUSTRY)
{
	decl iNumGrades, mTransitions, mExposures, vSelect, iNumObs, temp, mWithdrawals, mEntrances;
	pmYg[0] = loadmat("CSKL_mMacrosMonthly.in7");
	// 1. ind pro
	// 2. unemployment
	// 3. term spread
	// 4. credit spread
	// 5. stock market return
	// 6. realized vol
	// 7. corporate net cash flows
	// 8. real gdp
	// 9. corporate profits
	vSelect = <0;1;7;3;4;5>;
	pmYg[0] = pmYg[0][vSelect][];
	pvTime[0] = loadmat("CSKL_vTimeMonthly.in7");

	// = <1;2;3;4;5;7;8;9;10;11;13;14;15;16;17;19>;
	if(INDUSTRY==0)
	{
		mTransitions = loadmat("Events0.in7")[][]';
		mTransitions = mTransitions + loadmat("Events1.in7")[][]';
		mTransitions = mTransitions + loadmat("Events2.in7")[][]';
		mTransitions = mTransitions + loadmat("Events3.in7")[][]';
		mTransitions = mTransitions + loadmat("Events4.in7")[][]';
		mTransitions = mTransitions + loadmat("Events5.in7")[][]';
		mTransitions = mTransitions + loadmat("Events6.in7")[][]';
		//println(mTransitions[][10:20]);
		mExposures = loadmat("Exposures0.in7")[][]';
		mExposures = mExposures + loadmat("Exposures1.in7")[][]';
		mExposures = mExposures + loadmat("Exposures2.in7")[][]';
		mExposures = mExposures + loadmat("Exposures3.in7")[][]';
		mExposures = mExposures + loadmat("Exposures4.in7")[][]';
		mExposures = mExposures + loadmat("Exposures5.in7")[][]';
		mExposures = mExposures + loadmat("Exposures6.in7")[][]';
		//println(mExposures[][10:20]);
		mWithdrawals = loadmat("Withdrawals0.in7")[][0:3]';
		mWithdrawals = mWithdrawals + loadmat("Withdrawals1.in7")[][0:3]';
		mWithdrawals = mWithdrawals + loadmat("Withdrawals2.in7")[][0:3]';
		mWithdrawals = mWithdrawals + loadmat("Withdrawals3.in7")[][0:3]';
		mWithdrawals = mWithdrawals + loadmat("Withdrawals4.in7")[][0:3]';
		mWithdrawals = mWithdrawals + loadmat("Withdrawals5.in7")[][0:3]';
		mWithdrawals = mWithdrawals + loadmat("Withdrawals6.in7")[][0:3]';
		mWithdrawals[][0] = 0;
		mEntrances = loadmat("Entrances0.in7")[][0:3]';
		mEntrances = mEntrances + loadmat("Entrances1.in7")[][0:3]';
		mEntrances = mEntrances + loadmat("Entrances2.in7")[][0:3]';
		mEntrances = mEntrances + loadmat("Entrances3.in7")[][0:3]';
		mEntrances = mEntrances + loadmat("Entrances4.in7")[][0:3]';
		mEntrances = mEntrances + loadmat("Entrances5.in7")[][0:3]';
		mEntrances = mEntrances + loadmat("Entrances6.in7")[][0:3]';
		temp = 	mExposures[0][0] | mExposures[4][0] | mExposures[8][0] | mExposures[12][0];
		mEntrances = temp ~ mEntrances[][0:348];
	}
	else
	{
	    mTransitions = loadmat("Events0.in7")[][]';
		mTransitions = mTransitions | loadmat("Events1.in7")[][]';
		mTransitions = mTransitions | loadmat("Events2.in7")[][]';
		mTransitions = mTransitions | loadmat("Events3.in7")[][]';
		mTransitions = mTransitions | loadmat("Events4.in7")[][]';
		mTransitions = mTransitions | loadmat("Events5.in7")[][]';
		mTransitions = mTransitions | loadmat("Events6.in7")[][]';
		mExposures = loadmat("Exposures0.in7")[][]';
		mExposures = mExposures | loadmat("Exposures1.in7")[][]';
		mExposures = mExposures | loadmat("Exposures2.in7")[][]';
		mExposures = mExposures | loadmat("Exposures3.in7")[][]';
		mExposures = mExposures | loadmat("Exposures4.in7")[][]';
		mExposures = mExposures | loadmat("Exposures5.in7")[][]';
		mExposures = mExposures | loadmat("Exposures6.in7")[][]';
	}
	iNumObs = columns(mTransitions);
	iNumGrades = rows(mWithdrawals);
 	decl mTrans = loadmat("smyp.in7");
	pmWith[0] = mWithdrawals;
	pmYc[0] = loadmat("smyp.in7");//mTransitions;
	pmRp[0] = mExposures;
	pmEnter[0] = mEntrances;

		 //println(mTransitions[][0:5]);
	
	pmRetExp[0] = zeros(iNumGrades,iNumObs);
	pmExp[0] = zeros(iNumGrades,iNumObs);
	for(decl t=0;t<iNumObs-1;t++)
	{
		temp = reshape(pmYc[0][][t],iNumGrades,iNumGrades+1);
		pmRetExp[0][][t+1] = sumc(temp)';
		pmExp[0][0][t] = mExposures[0][t];
		pmExp[0][1][t] = mExposures[4][t];
		pmExp[0][2][t] = mExposures[8][t];
		pmExp[0][3][t] = mExposures[12][t];
	}
	pmRetExp[0][][0] = pmExp[0][][0];
			 // NOTE the first month is different
			 //println("Transitions: ", mTrans[][0:5]);
			 //println("Withdrawals this month: ", mWithdrawals[][0:5]);
			 //println("Entrances added this month: ", mEntrances[][0:5]);
			 //println("Exposures retained from prior month: ", pmRetExp[0][][0:5]);
			 //println("Total exposures this month: ", pmExp[0][][0:5]);
	
	temp = loadmat("LGDs.in7")[0:1341][]';
	pmYr[0] = temp;
	decl t, j, count1, temp2, temp3, temp4, vIndex;
	temp2 = ones(22,iNumObs)*.NaN;
	temp3 = ones(22,iNumObs)*.NaN;
	for(t=0;t<iNumObs;t++)
	{
		vIndex = t*ones(1,columns(pmYr[0])).==pmYr[0][0][];
		temp = selectifc(pmYr[0][3][],vIndex)';
		temp = deleter(temp);
		temp4 = selectifc(pmYr[0][2][],vIndex)';
		temp4 = deleter(temp4);
		for(j=0;j<rows(temp);j++)
		{
			temp2[j][t] = temp[j];
			temp3[j][t]	= temp4[j];
		}
	}
	pmLr[0] = temp2;
	pmLi[0] = temp3;

	//println(pmLr[0]);
	//pmYr[0] = pmLr[0];
	//println(rows(pmYr[0])~columns(pmYr[0]));
	//println(rows(pmLr[0])~columns(pmLr[0]));
}
																									  
computePercentages(const mYc, const pmExp, const pmTrInto, const pmPerc, const pmActual)
{
	decl iT = columns(mYc);
	decl iN = rows(mYc);
	decl mEnter = zeros(4,iT);
	decl mWithdrawals = zeros(4,iT);
	decl temp, temp1, temp2;
	decl t, vTotal;

	pmPerc[0] = zeros(4,iT);
	pmTrInto[0] = zeros(5,iT);
	pmExp[0] = zeros(4,iT);
	pmActual[0] = zeros(2,iT);

	for(t=0;t<iT;t++)
	{
		temp = reshape(mYc[][t],4,5);
		pmTrInto[0][][t] = sumc(temp)';

		temp1 = setlower(temp,0);
		temp1 = setdiagonal(temp1,0);

		// actual number of downgrades
		pmActual[0][0][t] = sumc(sumr(temp1));

		temp2 = setupper(temp,0);
		temp2 = setdiagonal(temp2,0); 

		// actual number of upgrades
		pmActual[0][1][t] = sumc(sumr(temp2));
	}
	//println(pmTrInto[0][][0:5]);
	pmPerc[0] = pmTrInto[0][][]./sumc(pmTrInto[0][][]);
	
	//println(pmPerc[0][][0:5]);
//	return;
//	pmExp[0][0][1:iT-1] = mYc[0][0:iT-2] + mYc[5][0:iT-2] + mYc[10][0:iT-2] + mYc[15][0:iT-2];
//	pmExp[0][1][1:iT-1] = mYc[1][0:iT-2] + mYc[6][0:iT-2] + mYc[11][0:iT-2] + mYc[16][0:iT-2];
//	pmExp[0][2][1:iT-1] = mYc[2][0:iT-2] + mYc[7][0:iT-2] + mYc[12][0:iT-2] + mYc[17][0:iT-2];
//	pmExp[0][3][1:iT-1] = mYc[3][0:iT-2] + mYc[8][0:iT-2] + mYc[13][0:iT-2] + mYc[18][0:iT-2];
//	pmExp[0][][0] = pmExp[0][][1];
	//pmExp[0][4][0:iT-1] = mYc[4][0:iT-1] + mYc[9][0:iT-1] + mYc[14][0:iT-1] + mYc[19][0:iT-1];

//	println(pmExp[0][][0:5]);
//
//	println(reshape(mYc[][0],4,5));
//	println(sumr(reshape(mYc[][0],4,5)));
}

drawBetaDistributions(const pmLr, const vTime)
{
	decl mAB1, mAB2, mMeans1, mMeans2, mProbs1, mProbs2;
	decl vParms, dLoglike;
	// Dates to plot the beta distributions
	decl dMin = 306; // June 2006
	decl dMax = 336; // January 2009 maxcindex(s_mMeans');
	

	s_iModel = 11;
	vParms = getStartingValues();
	logLikelihoodDiagnostics(vParms, &dLoglike, 0, 0); // Added by Drew
	mAB1 = s_mAB;
	mMeans1 = s_mMeans;
	mProbs1 = s_mProbs;
	decl vRandBeta11 = ranbeta(1,2000000, mAB1[0][dMin], mAB1[1][dMin]);
	decl vRandBeta12 = ranbeta(1,2000000, mAB1[0][dMax], mAB1[1][dMax]);

	s_iModel = 14;
	vParms = getStartingValues();
	logLikelihoodDiagnostics(vParms, &dLoglike, 0, 0); // Added by Drew
	mAB2 = s_mAB;
	mMeans2 = s_mMeans;
	mProbs2 = s_mProbs;
	decl vRandBeta21 = ranbeta(1,2000000, mAB2[0][dMin], mAB2[1][dMin]);
	decl vRandBeta22 = ranbeta(1,2000000, mAB2[0][dMax], mAB2[1][dMax]);

	println(mProbs1[17][]'~range(0,349,1)');
	
	SetDrawWindow("Figure 4");
//	//DrawXMatrix(5, mPerc[4][], {""}, vTime, {""}, 0, 3);
//	//DrawXMatrix(1, sumc(s_mAB), vNames, vTime, {""}, 0, 3);
	DrawDensity(0, vRandBeta21, {" "}, FALSE, TRUE, FALSE);
	DrawDensity(0, vRandBeta11, {" "}, FALSE, TRUE, FALSE);
	DrawXMatrix(1, mMeans1[0][], {"(4,0,0)"}, vTime, {""}, 0, 1);
	DrawXMatrix(1, mMeans2[0][], {"(4,2,0)"}, vTime, {""}, 0, 3);
	for(decl i=0;i<rows(pmLr[0]);i++)
	{
		DrawXMatrix(1, pmLr[0][i][], {" "}, vTime, {""}, 1, 2);
	}
	//vYr = deleter(selectifc(mYr[3][],mYr[0][] .== t)');
	DrawDensity(2, vRandBeta22, {" "}, FALSE, TRUE, FALSE);
	DrawDensity(2, vRandBeta12, {" "}, FALSE, TRUE, FALSE);
	DrawXMatrix(3, mProbs1[17][], {"(4,0,0)"}, vTime, {""}, 0, 1);
	DrawXMatrix(3, mProbs2[17][], {"(4,2,0)"}, vTime, {""}, 0, 3);
	//SaveDrawWindow("Predictions versus outcomes.eps");
	ShowDrawWindow();
	
}

main()
{

	decl vQuarterIndex, vFitted, vTime, vParms, vParmsMLE, vStdErrors, vDraws;
	decl dLoglike, ir, i, j, t, iNumTotalObs;
	decl vMuZ, vPIT1, vPIT2, vPIT3, vPIT4, temp1, temp2, temp3, mEc, mYg, mRp, mWith, mExp, mRetExp, mYc, mYr, mLr, mLi, inc, mEnter;
	decl vPIT_LGD, vPIT_M;
	
	//for (s_iModel = 3;s_iModel<11; ++s_iModel) {
	s_iModel = 17;
	
	
	getData(&mYg, &vTime, &mRp, &mWith, &mExp, &mEnter, &mRetExp, &mYc, &mYr, &mLr, &mLi, 0);
				 
	s_mYg = mYg;
	s_vTime = vTime;
	s_mRp = mRp;
	s_mYc = mYc;
	s_mYr = mYr;
	s_mWith = mWith;
	s_mRetExp = mRetExp;
				
//	    SetDrawWindow("Entrances and Withdrawals");
//		DrawXMatrix(0, mEnter[0][1:], {"IG-enter"}, vTime, {" "}, 2, 2);
//		DrawXMatrix(1, mEnter[1][1:], {"BB-enter"}, vTime, {" "}, 2, 2);
//		DrawXMatrix(2, mEnter[2][1:], {"B-enter"}, vTime, {" "}, 2, 2);
//		DrawXMatrix(3, mEnter[3][1:], {"CCC-enter"}, vTime, {" "}, 2, 2);
//		DrawXMatrix(0, mWith[0][1:], {"IG-withdraw"}, vTime, {" "}, 2, 3);
//		DrawXMatrix(1, mWith[1][1:], {"BB-withdraw"}, vTime, {" "}, 2, 3);
//		DrawXMatrix(2, mWith[2][1:], {"B-withdraw"}, vTime, {" "}, 2, 3);
//		DrawXMatrix(3, mWith[3][1:], {"CCC-withdraw"}, vTime, {" "}, 2, 3);
//		//printNBER(0, minc(s_mX[8][]')-0.1, maxc(s_mX[8][]')+0.1);
//		ShowDrawWindow();
//		
//		 SetDrawWindow("Entrances minus Withdrawals 2");
//		DrawXMatrix(0, mEnter[0][1:] - mWith[0][1:], {"IG-diff"}, vTime, {" "}, 2, 2);
//		DrawXMatrix(1, mEnter[1][1:] - mWith[1][1:], {"BB-diff"}, vTime, {" "}, 2, 2);
//		DrawXMatrix(2, mEnter[2][1:] - mWith[2][1:], {"B-diff"}, vTime, {" "}, 2, 2);
//		DrawXMatrix(3, mEnter[3][1:] - mWith[3][1:], {"CCC-diff"}, vTime, {" "}, 2, 2);
//		ShowDrawWindow();

	//	return;
//		 	SetDrawWindow("data");
//	DrawAdjust(ADJ_AREAMATRIX, 4, 4);
//	DrawXMatrix(0, s_mYc[1][], {"IG to BB"}, vTime, {""}, 0, 3);
//	DrawXMatrix(1, s_mYc[2][], {"IG to B"}, vTime, {""}, 0, 3);
//	DrawXMatrix(2, s_mYc[3][], {"IG to CCC"}, vTime, {""}, 0, 3);
//	DrawXMatrix(3, s_mYc[4][], {"IG to Default"}, vTime, {""}, 0, 3);
//	DrawXMatrix(4, s_mYc[5][], {"BB to IG"}, vTime, {""}, 0, 3);
//	DrawXMatrix(5, s_mYc[7][], {"BB to B"}, vTime, {""}, 0, 3);
//	DrawXMatrix(6, s_mYc[8][], {"BB to CCC"}, vTime, {""}, 0, 3);
//	DrawXMatrix(7, s_mYc[9][], {"BB to Default"}, vTime, {""}, 0, 3);
//	DrawXMatrix(8, s_mYc[10][], {"B to IG"}, vTime, {""}, 0, 3);
//	DrawXMatrix(9, s_mYc[11][], {"B to BB"}, vTime, {""}, 0, 3);
//	DrawXMatrix(10, s_mYc[12][], {"B to CCC"}, vTime, {""}, 0, 3);
//	DrawXMatrix(11, s_mYc[14][], {"B to Default"}, vTime, {""}, 0, 3);
//	DrawXMatrix(12, s_mYc[15][], {"CCC to IG"}, vTime, {""}, 0, 3);
//	DrawXMatrix(13, s_mYc[16][], {"CCC to BB"}, vTime, {""}, 0, 3);
//	DrawXMatrix(14, s_mYc[17][], {"CCC to B"}, vTime, {""}, 0, 3);
//	DrawXMatrix(15, s_mYc[18][], {"CCC to Default"}, vTime, {""}, 0, 3);
//	ShowDrawWindow();

	s_mYg = (s_mYg - meanr(deletec(s_mYg))) ./sqrt(varr(deletec(s_mYg)));
	s_mYg = s_mYg[0:5][];
	vQuarterIndex = range(0,columns(s_mYg),3);
	s_iNumObs = columns(s_mYg);
	s_iRestrict = 1;
	s_iPrint = 0;
	s_iPlot = 0;
	s_iInfoSmooth = 1;	  
			   		 
	s_vParmsOrig = 1;
	vParms = getStartingValues();
	decl mTrInto, mExpo, mPerc, mActual;
	computePercentages(s_mYc, &mExpo, &mTrInto, &mPerc, &mActual);
						
	//logLikelihood(vParms, &dLoglike, 0, 0);
	logLikelihoodDiagnostics(vParms, &dLoglike, 0, 0); // Added by Drew
					  //return;
	
//	savemat("mScaledScores_(4,2,0)_6_25_2012.in7",s_mScaledScores);

//	return;
//	temp1 = vTime | s_mYg[2][] | s_mPred[2][];
//	temp1 = deletec(temp1);
//	SetDrawWindow("Macros and Fits");
//	DrawXMatrix(0, s_mPred[0][1:], {" "}, vTime, {""}, 0, 2);
//	DrawXMatrix(0, s_mYg[0][], {"  "}, vTime, {""}, 0, 3);
//	DrawXMatrix(1, s_mPred[1][1:], {" "}, vTime, {""}, 0, 2);
//	DrawXMatrix(1, s_mYg[1][], {"  "}, vTime, {""}, 0, 3);
//	//DrawXMatrix(2, s_mPred[2][1:], {" "}, vTime, {""}, 0, 2);
//	//DrawXMatrix(2, s_mYg[2][], {"  "}, vTime, {""}, 0, 3);
//	DrawXMatrix(2, temp1[1][], {" "}, temp1[0][], {""}, 0, 2);
//	DrawXMatrix(2, temp1[2][], {"  "}, temp1[0][], {""}, 0, 3);
//	DrawXMatrix(3, s_mPred[3][1:], {""}, vTime, {""}, 0, 2);
//	DrawXMatrix(3, s_mYg[3][], {"  "}, vTime, {""}, 0, 3);
//	DrawXMatrix(4, s_mPred[4][1:], {""}, vTime, {""}, 0, 2);
//	DrawXMatrix(4, s_mYg[4][], {"  "}, vTime, {""}, 0, 3);
//	DrawXMatrix(5, s_mPred[5][1:], {""}, vTime, {""}, 0, 2);
//	DrawXMatrix(5, s_mYg[5][], {"  "}, vTime, {""}, 0, 3);
//		DrawAdjust(ADJ_AREAMATRIX, 2, 3);
//	//SaveDrawWindow("Predictions versus outcomes.eps");
//	ShowDrawWindow();


	//println(mYr);
	//return;
	//drawBetaDistributions(&mLr, vTime);
	
	//return;
	
	SetDrawWindow("Actual downgrades vs predicted downgrades");
	DrawXMatrix(0, mActual[0][], {"Actual downgrades vs predicted downgrades"}, s_mPredicted[0][], {""}, 1, 3);
	//DrawXMatrix(1, mPred[1][], {"BB"}, s_mPredicted[1][], {""}, 1, 3);
	//DrawXMatrix(2, mPred[2][], {"B"}, s_mPredicted[2][], {""}, 1, 3);
	//DrawXMatrix(3, mPerc[3][], {"CCC"}, s_mPredicted[3][], {""}, 1, 3);
	//DrawXMatrix(4, mPerc[4][], {"Default"}, s_mPredicted[4][], {""}, 1, 3);
	//DrawXMatrix(4, mPerc[4][], {"Default"}, s_mPredicted[4][], {""}, 1, 3);
	//DrawXMatrix(4, mPerc[4][], {""}, vTime, {""}, 0, 3);
	//DrawXMatrix(5, mPerc[4][], {""}, vTime, {""}, 0, 3);
	//DrawXMatrix(1, sumc(s_mAB), vNames, vTime, {""}, 0, 3);
//	//DrawDensity(2, temp2, {"LGDs"}, FALSE, TRUE, FALSE);
//	//DrawDensity(1, ranu(1,columns(temp1)), {"random uniforms"}, FALSE, TRUE, FALSE);
//	//DrawDensity(3, ranu(1,columns(temp2)), {"random uniforms"}, FALSE, TRUE, FALSE);
	//SaveDrawWindow("Predictions versus outcomes.eps");
	ShowDrawWindow();

	SetDrawWindow("Actual upgrades vs predicted upgrades");
	//DrawXMatrix(0, mPred[0][], {"IG"}, s_mPredicted[0][], {""}, 1, 3);
	DrawXMatrix(0, mActual[1][], {"Actual upgrades vs predicted upgrades"}, s_mPredicted[1][], {""}, 1, 3);
	//DrawXMatrix(2, mPred[2][], {"B"}, s_mPredicted[2][], {""}, 1, 3);
	//DrawXMatrix(3, mPerc[3][], {"CCC"}, s_mPredicted[3][], {""}, 1, 3);
	//DrawXMatrix(4, mPerc[4][], {"Default"}, s_mPredicted[4][], {""}, 1, 3);
	//DrawXMatrix(4, mPerc[4][], {"Default"}, s_mPredicted[4][], {""}, 1, 3);
	//DrawXMatrix(4, mPerc[4][], {""}, vTime, {""}, 0, 3);
	//DrawXMatrix(5, mPerc[4][], {""}, vTime, {""}, 0, 3);
	//DrawXMatrix(1, sumc(s_mAB), vNames, vTime, {""}, 0, 3);
//	//DrawDensity(2, temp2, {"LGDs"}, FALSE, TRUE, FALSE);
//	//DrawDensity(1, ranu(1,columns(temp1)), {"random uniforms"}, FALSE, TRUE, FALSE);
//	//DrawDensity(3, ranu(1,columns(temp2)), {"random uniforms"}, FALSE, TRUE, FALSE);
	//SaveDrawWindow("Predictions versus outcomes.eps");
	ShowDrawWindow();
//
//	// 15 and 308
//	
//	decl vResids, beta_hat, X, Y, s2;  
//	decl vIndex = range(0,s_iNumObs-1,1)';
//	decl mSig, mD, vA, vP, iT;
//	
//	mD = ones(s_iNumObs,1) ~ vIndex ~ mActual[0][]' ~ s_mPredicted[0][]' ~ s_mPredicted[2][]' ~ mActual[0][]' - s_mPredicted[0][]';
//	mD = deleter(mD);
//	iT = rows(mD);
//	mSig = diag(1 ./mD[][4]);
//	//mSig = unit(iT);
//
//	//println(mSig);
//	Y = mD[][2];
//	X = ones(iT,1) ~ mD[][3];
//	beta_hat = invert(X'*mSig*X)*(X'*mSig*Y);
//	vResids = Y - X*beta_hat;
//	s2 = 1;//(1/(iT-2))*sumc(vResids.^2);
//	//println(beta_hat);
//	//println(sqrt((s2)*diagonal(invert(X'*mSig*X))));
//
//	mD = ones(s_iNumObs,1) ~ vIndex ~ mActual[1][]' ~ s_mPredicted[1][]' ~ mActual[1][]' - s_mPredicted[1][]';
//	mD = deleter(mD);
//
//	Y = mD[][2];
//	X = ones(s_iNumObs-3,1) ~ mD[][3];
//	beta_hat = invert(X'X)*(X'Y);
//	vResids = Y - X*beta_hat;
//	s2 = (1/(iT-2))*sumc(vResids.^2);
//	//println(beta_hat);
//	//println(sqrt((s2)*diagonal(invert(X'X))));
//
//	SetDrawWindow("Residuals");
//	DrawXMatrix(0, mActual[0][], {"Actual downgrades vs predicted downgrades"}, s_mPredicted[0][], {""}, 1, 3);//DrawXMatrix(0, fabs(mActual[0][] - s_mPredicted[0][]), {"Absolute-value of prediction errors downgrades vs. predicted variance"}, s_mPredicted[2][], {""}, 1, 3);
//	DrawXMatrix(1, mActual[1][], {"Actual upgrades vs predicted upgrades"}, s_mPredicted[1][], {""}, 1, 3);//DrawXMatrix(1, fabs(mActual[1][] - s_mPredicted[1][]), {"Absolute-value of prediction errors upgrades vs. predicted variance"}, s_mPredicted[3][], {""}, 1, 3);
//	DrawXMatrix(2, (mActual[0][] - s_mPredicted[0][])./sqrt(s_mPredicted[2][]), {"Standardized residuals of the prediction errors"}, vTime, {""}, 1, 3);
//	DrawXMatrix(3, (mActual[1][] - s_mPredicted[1][])./sqrt(s_mPredicted[3][]), {"Standardized residuals of the prediction errors"}, vTime, {""}, 1, 3);
//	//SaveDrawWindow("Predictions versus outcomes.eps");
//	ShowDrawWindow();

//	return;
////	
////	SetDrawWindow("Predicted Defaults");
////	DrawXMatrix(0, s_mPredicted[4][], {"One-step ahead predicted defaults"}, vTime, {""}, 0, 2);
////	DrawXMatrix(0, s_mPredicted[5][], {"Actual defaults"}, vTime, {""}, 1, 3);
////	DrawXMatrix(1, s_mPredicted[4][], {"Actual defaults"}, s_mPredicted[5][], {""}, 1, 3);
////	DrawXMatrix(2, s_mPredicted[4][], {"One-step ahead predicted defaults"}, vTime, {""}, 0, 2);
////	DrawXMatrix(2, s_mPredicted[5][], {"Actual defaults"}, vTime, {""}, 1, 3);
////	DrawXMatrix(3, s_mPredicted[4][], {"Actual defaults"}, s_mPredicted[5][], {""}, 1, 3);
////	//SaveDrawWindow("Predictions versus outcomes.eps");
////	ShowDrawWindow();
//
//	//return;
//	//println("loglikelihood: ",dLoglike);
//
//	//println(s_mProbIntegralsMacros[][]);
//	//println(s_mProbIntegralsLGDs[][0:50]);
//
////	SetDrawWindow("density evaluation 1");
////	DrawDensity(0, deletec(s_mProbIntegralsMacros[0][]), {"macro 1"}, FALSE, TRUE, FALSE);
////	DrawDensity(1, deletec(s_mProbIntegralsMacros[1][]), {"macro 2"}, FALSE, TRUE, FALSE);
////	DrawDensity(2, deletec(s_mProbIntegralsMacros[2][]), {"macro 3"}, FALSE, TRUE, FALSE);
////	DrawDensity(3, deletec(s_mProbIntegralsMacros[3][]), {"macro 4"}, FALSE, TRUE, FALSE);
////	DrawDensity(4, deletec(s_mProbIntegralsMacros[4][]), {"macro 5"}, FALSE, TRUE, FALSE);
////	DrawDensity(5, deletec(s_mProbIntegralsMacros[5][]), {"macro 6"}, FALSE, TRUE, FALSE);
//////	DrawDensity(5, temp2, {"LGDs"}, FALSE, TRUE, FALSE);
////	//SaveDrawWindow("prob_integrals_macros.eps");
////	ShowDrawWindow();
////					//println(s_mScaledResids[2][]');
////	SetDrawWindow("scaled residuals");
////	DrawXMatrix(0, s_mScaledResids[0][], {"ind pro"}, vTime, {""}, 0, 3);
////	DrawXMatrix(1, s_mScaledResids[1][], {"unemployment"}, vTime, {""}, 0, 3);
////	DrawXMatrix(2, deletec(s_mScaledResids[2][]), {"rgdp"}, vTime, {""}, 0, 3);
////	DrawXMatrix(3, s_mScaledResids[3][], {"credit spread"}, vTime, {""}, 0, 3);
////	DrawXMatrix(4, s_mScaledResids[4][], {"SP500 return"}, vTime, {""}, 0, 3);
////	DrawXMatrix(5, s_mScaledResids[5][], {"SP500 volatility"}, vTime, {""}, 0, 3);
////	//SaveDrawWindow("Predictions versus outcomes.eps");
////	ShowDrawWindow();
//
//	//return;
//
//	SetDrawWindow("Raw Data");
//	DrawXMatrix(0, s_mYg[0][], {"ind pro"}, vTime, {""}, 0, 2);
//	DrawXMatrix(0, s_mYg[1][], {"unemployment"}, vTime, {""}, 0, 3);
//	DrawXMatrix(1, s_mScaledResids[0][], {"ind pro residuals"}, vTime, {""}, 0, 3);
//	DrawXMatrix(2, s_mScaledResids[1][], {"unemployment residuals"}, vTime, {""}, 0, 3);
//	DrawXMatrix(3, s_mYg[0][]*-1, {"ind pro * -1"}, vTime, {""}, 0, 2);
//	DrawXMatrix(3, s_mYg[1][], {"unemployment"}, vTime, {""}, 0, 3);
//	//SaveDrawWindow("Predictions versus outcomes.eps");
//	ShowDrawWindow();
//
//	SetDrawWindow("Residuals");
//	DrawAcf(0, s_mScaledResids[0][], {"ind pro"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(1, s_mScaledResids[1][], {"unemployment"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(2, deletec(s_mScaledResids[2][]), {"rgdp"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(3, s_mScaledResids[3][], {"credit spread"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(4, s_mScaledResids[4][], {"SP500 return"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(5, s_mScaledResids[5][], {"SP500 volatility"}, 50, TRUE, FALSE, TRUE);
//	//DrawDensity(6, vPIT_M, {"combined macros"}, FALSE, TRUE, FALSE, FALSE);
//	//DrawDensity(7, vPIT_LGD, {"LGDs"}, FALSE, TRUE, FALSE, FALSE);
//	//SaveDrawWindow("ACF_first_moment_macros.eps");
//	ShowDrawWindow();
//
//	SetDrawWindow("Data");
//	DrawAcf(0, s_mYg[0][], {"ind pro"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(1, s_mYg[1][], {"unemployment"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(2, deletec(s_mYg[2][]), {"rgdp"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(3, s_mYg[3][], {"credit spread"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(4, s_mYg[4][], {"SP500 return"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(5, s_mYg[5][], {"SP500 volatility"}, 50, TRUE, FALSE, TRUE);
//	//DrawDensity(6, vPIT_M, {"combined macros"}, FALSE, TRUE, FALSE, FALSE);
//	//DrawDensity(7, vPIT_LGD, {"LGDs"}, FALSE, TRUE, FALSE, FALSE);
//	//SaveDrawWindow("ACF_first_moment_macros.eps");
//	ShowDrawWindow();
//
//
//	SetDrawWindow("Data - residuals v2");
//	DrawAcf(0, s_mYg[0][], {"ind pro"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(1, s_mScaledResids[0][], {"ind pro"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(2, s_mYg[1][], {"unemployment"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(3, s_mScaledResids[1][], {"unemployment"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(4, deletec(s_mYg[2][]), {"rgdp"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(5, deletec(s_mScaledResids[2][]), {"rgdp"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(6, s_mYg[3][], {"credit spread"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(7, s_mScaledResids[3][], {"credit spread"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(8, s_mYg[4][], {"SP500 return"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(9, s_mScaledResids[4][], {"SP500 return"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(10, s_mYg[5][], {"SP500 volatility"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(11, s_mScaledResids[5][], {"SP500 volatility"}, 50, TRUE, FALSE, TRUE);
//	//DrawDensity(6, vPIT_M, {"combined macros"}, FALSE, TRUE, FALSE, FALSE);
//	//DrawDensity(7, vPIT_LGD, {"LGDs"}, FALSE, TRUE, FALSE, FALSE);
//	//SaveDrawWindow("ACF_first_moment_macros.eps");
//	DrawAdjust(ADJ_AREAMATRIX, 6, 2);
//	ShowDrawWindow();
//
//	//return;
//	
//	vMuZ = meanr(deletec(s_mProbIntegralsMacros));
//	vPIT1 = deletec(s_mProbIntegralsMacros) - vMuZ;
//	vPIT2 = (deletec(s_mProbIntegralsMacros) - vMuZ).^2;
//	vPIT3 = (deletec(s_mProbIntegralsMacros) - vMuZ).^3;
//	vPIT4 = (deletec(s_mProbIntegralsMacros) - vMuZ).^4;	
//
//	SetDrawWindow("ACF first moment Z");
//	DrawAcf(0, vPIT1[0][], {"macro 1"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(1, vPIT1[1][], {"macro 2"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(2, vPIT1[2][], {"macro 3"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(3, vPIT1[3][], {"macro 4"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(4, vPIT1[4][], {"macro 5"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(5, vPIT1[5][], {"macro 6"}, 50, TRUE, FALSE, TRUE);
//	//SaveDrawWindow("ACF_first_moment_macros.eps");
//	ShowDrawWindow();
//
//	SetDrawWindow("ACF second moment Z");
//	DrawAcf(0, vPIT2[0][], {"macro 1"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(1, vPIT2[1][], {"macro 2"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(2, vPIT2[2][], {"macro 3"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(3, vPIT2[3][], {"macro 4"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(4, vPIT2[4][], {"macro 5"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(5, vPIT2[5][], {"macro 6"}, 50, TRUE, FALSE, TRUE);
//	//SaveDrawWindow("ACF_second_moment_macros.eps");
//	ShowDrawWindow();
//
//	SetDrawWindow("ACF third moment Z");
//	DrawAcf(0, vPIT3[0][], {"macro 1"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(1, vPIT3[1][], {"macro 2"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(2, vPIT3[2][], {"macro 3"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(3, vPIT3[3][], {"macro 4"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(4, vPIT3[4][], {"macro 5"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(5, vPIT3[5][], {"macro 6"}, 50, TRUE, FALSE, TRUE);
//	//SaveDrawWindow("ACF_third_moment_macros.eps");
//	ShowDrawWindow();
//
//	SetDrawWindow("ACF fourth moment Z");
//	DrawAcf(0, vPIT4[0][], {"macro 1"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(1, vPIT4[1][], {"macro 2"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(2, vPIT4[2][], {"macro 3"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(3, vPIT4[3][], {"macro 4"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(4, vPIT4[4][], {"macro 5"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(5, vPIT4[5][], {"macro 6"}, 50, TRUE, FALSE, TRUE);
//	//SaveDrawWindow("ACF_fourth_moment_macros.eps");
//	ShowDrawWindow();
//	
//	vPIT_M = deleter(vec(s_mProbIntegralsMacros))';
//	vPIT_LGD = deleter(vec(s_mProbIntegralsLGDs))';
//	temp3 = ranu(1,1000000);
//
////	vMuZ = meanr(temp2);
////	
////	vPIT1 = temp2 - vMuZ;
////	vPIT2 = (temp2 - vMuZ).^2;
////	vPIT3 = (temp2 - vMuZ).^3;
////	vPIT4 = (temp2 - vMuZ).^4;
////
////	SetDrawWindow("ACF LGDs Z");
////	DrawAcf(0, vPIT1[0][], {"first moment"}, 50, TRUE, FALSE, TRUE);
////	DrawAcf(1, vPIT2[0][], {"second moment"}, 50, TRUE, FALSE, TRUE);
////	DrawAcf(2, vPIT3[0][], {"third moment"}, 50, TRUE, FALSE, TRUE);
////	DrawAcf(3, vPIT4[0][], {"fourth moment"}, 50, TRUE, FALSE, TRUE);
////	//SaveDrawWindow("ACF_LGDs.eps");
////	ShowDrawWindow();
//
//		decl CI, p = 1/11; // 1 divided by the number of bins
//	CI = 2*sqrt(p*(1-p)*columns(vPIT_LGD));
//	println(columns(vPIT_LGD));
//	println(CI/100);
//	CI = 2*sqrt(p*(1-p)*columns(vPIT_M));
//	println(columns(vPIT_M));
//	println(CI/100);
//	
//	
//	SetDrawWindow("Diagnostic");
//	DrawAcf(0, vPIT1[0][], {"macro 1"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(1, vPIT1[1][], {"macro 2"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(2, vPIT1[2][], {"macro 3"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(3, vPIT1[3][], {"macro 4"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(4, vPIT1[4][], {"macro 5"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(5, vPIT1[5][], {"macro 6"}, 50, TRUE, FALSE, TRUE);
//	DrawDensity(6, vPIT_M, {"combined macros"}, FALSE, TRUE, FALSE, FALSE);
//	DrawDensity(7, vPIT_LGD, {"LGDs"}, FALSE, TRUE, FALSE, FALSE);
//	//SaveDrawWindow("ACF_first_moment_macros.eps");
//	ShowDrawWindow();
//
//	SetDrawWindow("Diagnostic 2");
//	DrawDensity(0, vPIT_M, {"combined macros"}, FALSE, TRUE, FALSE, FALSE);
//	DrawDensity(1, vPIT_LGD, {"LGDs"}, FALSE, TRUE, FALSE, FALSE);
//	DrawAcf(2, vPIT1[0][], {"macro 1"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(3, vPIT1[1][], {"macro 2"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(4, vPIT1[2][], {"macro 3"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(5, vPIT1[3][], {"macro 4"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(6, vPIT1[4][], {"macro 5"}, 50, TRUE, FALSE, TRUE);
//	DrawAcf(7, vPIT1[5][], {"macro 6"}, 50, TRUE, FALSE, TRUE);
////	//SaveDrawWindow("ACF_first_moment_macros.eps");
//	ShowDrawWindow();
//
////	return;
//	
//
//	SetDrawWindow("density evaluation 2 (3,2,0)");
//	DrawDensity(0, vPIT_M, {"combined macros"}, TRUE, TRUE, FALSE, FALSE);
//	DrawDensity(2, vPIT_LGD, {"LGDs"}, TRUE, TRUE, FALSE, FALSE);
//	//DrawDensity(1, ranu(1,columns(temp1)), {"random uniforms"}, FALSE, TRUE, FALSE);
//	//DrawDensity(3, ranu(1,columns(temp2)), {"random uniforms"}, FALSE, TRUE, FALSE);
//	//SaveDrawWindow("probability_integrals_LGDs.eps");
//	ShowDrawWindow();
//
////	return;
//	SetDrawWindow("Scaled scores");
//	DrawXMatrix(0, s_mScaledScores[0][], {"macro factor 1"}, vTime, {""}, 0, 3);
//	DrawXMatrix(1, s_mScaledScores[1][], {"macro factor 2"}, vTime, {""}, 0, 3);
//	DrawXMatrix(2, s_mScaledScores[2][], {"macro factor 3"}, vTime, {""}, 0, 3);
//	DrawXMatrix(3, s_mScaledScores[3][], {"frailty factor 1"}, vTime, {""}, 0, 3);
//	DrawXMatrix(4, s_mScaledScores[4][], {"frailty factor 2"}, vTime, {""}, 0, 3);
//	//SaveDrawWindow("scaled_scores_3_2_0.eps");
//	ShowDrawWindow();
	
//
//	SetDrawWindow("beta");
//	DrawDensity(0, ranbeta(1,10000,0.9,1.2), {"combined macros"}, FALSE, TRUE, FALSE);
//	DrawDensity(1, ranbeta(1,10000,0.9,2), {"LGDs"}, FALSE, TRUE, FALSE);
//	DrawDensity(2, ranbeta(1,10000,1.2,0.9), {"random uniforms"}, FALSE, TRUE, FALSE);
//	DrawDensity(3, ranbeta(1,10000,2,0.9), {"random uniforms"}, FALSE, TRUE, FALSE);
//	//SaveDrawWindow("probability_integrals_LGDs.eps");
//	ShowDrawWindow();
	

//	return;
	
	//savemat("mScaledScores_(3,2,0)_12_1_2010.in7",s_mScaledScores);
					 
	iNumTotalObs = sumr(sumc(s_mYc)) + columns(s_mYr);
	for(t=0;t<s_iNumObs;t++) iNumTotalObs += rows(deleter(s_mYg[][t]));
				//	return;

	println("loglikelihood: ",dLoglike);
	println("AIC: ",-2*dLoglike + 2*rows(vParms));
	//println("BIC: ",-2*dLoglike + rows(vParms)*log(sizerc(s_mYc)));
	println("BIC: ",-2*dLoglike + rows(vParms)*log(iNumTotalObs));
		  	  		
	MaxControl(-1,1,0);
	ir = MaxBFGS(logLikelihood, &vParms, &dLoglike, 0, 1);

	s_vParmsOrig = fabs(vParms);
	s_vParmsOrig = exp(round( 10* log(s_vParmsOrig) ) / 10 );
	vParms = 2 * (vParms .> 0) - 1;
	ir = MaxBFGS(logLikelihood, &vParms, &dLoglike, 0, 1);

	println("**********************************************************************************************");
	println("**********************************************************************************************");
	println("**********************************************************************************************");
	println("\n", MaxConvergenceMsg(ir),
          " using numerical derivatives",
          "\nFunction value = ", dLoglike);
	println("The model is (",s_iNumMacroFactors,",",s_iNumFrailtyFactors,",",s_iNumRecRateFactors,")");
	println("loglikelihood: ",dLoglike);	  
	println("AIC: ",-2*dLoglike + 2*rows(vParms));
    println("BIC: ",-2*dLoglike + rows(vParms)*log(iNumTotalObs));
	
	println(restrictParms(vParms));
	
	vParms .*= s_vParmsOrig;
	s_vParmsOrig = 1;
	  

	println(" ");
	for(decl j=0;j<rows(vParms); j++)
		print(vParms[j]," | ");
	println(" ");
				 	//return;
	standardErrors(logLikelihood, restrictParms, vParms, &vParmsMLE, &vStdErrors);
					  
	s_iPrint = 1;
	s_iRestrict = 0;
	logLikelihood(vParmsMLE,&dLoglike,0,0);
	logLikelihood(vStdErrors,&dLoglike,0,0);

	println(vParmsMLE);
	println(vStdErrors);
	savemat(sprint("par",s_iModel,".xls"),vParmsMLE~vStdErrors);

	//}
}